   This Info file documents GNU troff version 1.16.

   Published by the Free Software Foundation 59 Temple Place, Suite 330
Boston, MA  02111-1307  USA

   Copyright (C) 1994-2000 Free Software Foundation, Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided that the
entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Foundation.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided also
that the section entitled "GNU General Public License" is included
exactly as in the original, and provided that the entire resulting
derived work is distributed under the terms of a permission notice
identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that the section entitled "GNU General Public License"
may be included in a translation approved by the Free Software
Foundation instead of in the original English.

   This Info file documents groff version 1.16, the GNU implementation
of the troff typesetting system.

   This is an in-progress document; contributions, comments, or
contributions are welcome.  Send them to bug-groff@gnu.org.

GNU GENERAL PUBLIC LICENSE
**************************

                         Version 2, June 1991

     Copyright (C) 1989, 1991 Free Software Foundation, Inc.
     59 Temple Place, Suite 330, Boston, MA 02111, USA

     Everyone is permitted to copy and distribute verbatim copies of this
     license document, but changing it is not allowed.

Preamble
========

   The licenses for most software are designed to take away your
freedom to share and change it.  By contrast, the GNU General Public
License is intended to guarantee your freedom to share and change free
software - to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software Foundation's
software and to any other program whose authors commit to using it.
(Some other Free Software Foundation software is covered by the GNU
Library General Public License instead.)  You can apply it to your
programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it in
new free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to
copy, distribute and/or modify the software.

   Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The "Program",
     below, refers to any such program or work, and a "work based on
     the Program" means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term "modification".)  Each
     licensee is addressed as "you".

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's
     source code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an
     appropriate copyright notice and disclaimer of warranty; keep
     intact all the notices that refer to this License and to the
     absence of any warranty; and give any other recipients of the
     Program a copy of this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  2. You may modify your copy or copies of the Program or any portion
     of it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program
          or any part thereof, to be licensed as a whole at no charge
          to all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not
     apply to those sections when you distribute them as separate
     works.  But when you distribute the same sections as part of a
     whole which is a work based on the Program, the distribution of
     the whole must be on the terms of this License, whose permissions
     for other licensees extend to the entire whole, and thus to each
     and every part regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on
     a volume of a storage or distribution medium does not bring the
     other work under the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than
          your cost of physically performing source distribution, a
          complete machine-readable copy of the corresponding source
          code, to be distributed under the terms of Sections 1 and 2
          above on a medium customarily used for software interchange;
          or,

       c. Accompany it with the information you received as to the
          offer to distribute corresponding source code.  (This
          alternative is allowed only for noncommercial distribution
          and only if you received the program in object code or
          executable form with such an offer, in accord with
          Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either
     source or binary form) with the major components (compiler,
     kernel, and so on) of the operating system on which the executable
     runs, unless that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  4. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

  5. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this
     License to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program
     subject to these terms and conditions.  You may not impose any
     further restrictions on the recipients' exercise of the rights
     granted herein.  You are not responsible for enforcing compliance
     by third parties to this License.

  7. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who
     receive copies directly or indirectly through you, then the only
     way you could satisfy both it and this License would be to refrain
     entirely from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  8. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

  9. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such
     new versions will be similar in spirit to the present version, but
     may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies
     to it and "any later version", you have the option of following
     the terms and conditions either of that version or of any later
     version published by the Free Software Foundation.  If the Program
     does not specify a version number of this License, you may choose
     any version ever published by the Free Software Foundation.

 10. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted
     by the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                                NO WARRANTY

 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
     HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT
     WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT
     NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE
     QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
     PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
     SERVICING, REPAIR OR CORRECTION.

 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs
=============================================

   If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least the
"copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY NAME OF AUTHOR

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or (at
     your option) any later version.

     This program is distributed in the hope that it will be useful, but
     WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 19YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type
     `show w'.  This is free software, and you are welcome to redistribute
     it under certain conditions; type `show c' for details.

   The hypothetical commands `show w' and `show c' should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than `show w' and
`show c'; they could even be mouse-clicks or menu items - whatever
suits your program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright interest
     in the program `Gnomovision' (which makes passes at compilers)
     written by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.

Introduction
************

   GNU `troff' (or `groff') is a system for typesetting documents.
`troff' is very flexible and has been in existence (and use) for about
3 decades.  It is quite widespread and firmly entrenched in the UNIX
community.

What Is `groff'?
================

   `groff' belongs to an older generation of document preparation
systems, which operate more like compilers than the more recent
interactive WYSIWYG(1) (1) systems.
`groff' and its contemporary counterpart, TeX, both work using a
"batch" paradigm: The input (or "source") files are normal text files
with embedded formatting commands.  These files can then be processed
by `groff' to produce a typeset document on a variety of devices.

   Likewise, `groff' should not be confused with a "word processor",
since that term connotes an integrated system which includes an editor
and a text formatter.  Also, many word processors follow the WYSIWYG
paradigm which was discussed earlier.

   Although WYSIWYG systems may be easier to use, they have a number of
disadvantages compared to `troff':

   * They must be used on a graphics display to do any operations on a
     document.

   * Most of the WYSIWYG systems are either non-free or are not very
     portable.

   * `troff' is firmly entrenched in all UNIX systems.

   * It is difficult to have a wide range of capabilities available
     within the confines of a GUI/window system.

   * It is more difficult to make global changes to a document.

     "GUIs normally make it simple to accomplish simple actions and
     impossible to accomplish complex actions."  -Doug Gwyn (22/Jun/91
     in `comp.unix.wizards')

   (1) What You See Is What You Get

History
=======

   `troff' can trace its origins back to a formatting program called
`runoff', written by J. E. Saltzer, which ran on MIT's CTSS operating
system in the mid-sixties.  This name came from the common phrase of
the time "I'll run off a document."  Bob Morris ported it to the 635
architecture and called the program `roff' (an abbreviation of
`runoff').  It has then been rewritten as `rf' for the PDP-7 (before
having UNIX), and at the same time (1969), Doug McIllroy rewrote an
extended and simplified version of `roff' in the BCPL programming
language.

   The first version of UNIX was developed on a PDP-7 which was sitting
around Bell Labs.  In 1971 the developers wanted to get a PDP-11 for
further work on the operating system.  In order to justify the cost for
this system, they proposed that they would implement a document
formatting system for the AT&T patents division.  This first formatting
program was a reimplementation of McIllroy's `roff', written by
J. F. Ossanna.

   When they needed a more flexible language, a new version of `roff'
called `nroff' ("Newer `roff'") was written.  It had a much more
complicated syntax, but provided the basis for all future versions.
When they got a Graphic Systems CAT Phototypesetter, Ossanna wrote a
version of `nroff' which would drive it.  It was dubbed `troff', for
"typesetter `roff'", although many people have speculated that it
actually means "Times `roff'" because of the use of the Times font
family in `troff' by default.  As such, the name `troff' is pronounced
`t-roff' rather than `trough'.

   With `troff' came `nroff' (they were actually the same program
except for some `#ifdef's), which was for producing output for line
printers and character terminals.  It understood everything `troff'
did, and ignored the commands which were not applicable (e.g. font
changes).

   Since there are several things which cannot be done easily in
`troff', work on several preprocessors began.  These programs would
transform certain parts of a document into `troff', which made a very
natural use of pipes in UNIX.

   The `eqn' preprocessor allowed mathematical formulae to be specified
in a much simpler and more intuitive manner.  `tbl' is a preprocessor
for formatting tables.  The `refer' preprocessor (and the similar
program, `bib') processes citations in a document according to a
bibliographic database.

   Unfortunately, Ossanna's `troff' was written in PDP-11 assembly
language and produced output specifically for the CAT phototypesetter.
He rewrote it in C, although it was now 7000 lines of uncommented code
and still dependent on the CAT.  As the CAT became less common, and was
no longer supported by the manufacturer, the need to make it support
other devices became a priority.  However, before this could be done,
Ossanna was killed in an auto accident.

   So, Brian Kernighan took on the task of rewriting `troff'.  The
newly rewritten version produced a device independent code which was
very easy for postprocessors to read and translate to the appropriate
printer codes.  Also, this new version of `troff' (called `ditroff' for
"device independent `troff'") had several extensions, which included
drawing functions.

   Due to the additional abilities of the new version of `troff',
several new preprocessors appeared.  The `pic' preprocessor provides a
wide range of drawing functions.  Likewise the `ideal' preprocessor did
the same, although via a much different paradigm.  The `grap'
preprocessor took specifications for graphs, but, unlike other
preprocessors, produced `pic' code.

   James Clark began work on a GNU implementation of `ditroff' in
early 1989.  The first version, `groff' 0.3.1, was released June 1990.
`groff' included:

   * A replacement for `ditroff' with many extensions.

   * The `soelim', `pic', `tbl', and `eqn' preprocessors.

   * Postprocessors for character devices, PostScript, TeX DVI, and
     X windows.  GNU `troff' also eliminated the need for a separate
     `nroff' program with a postprocessor which would produce ASCII
     output.

   * A version of the `me' macros and an implementation of the `man'
     macros.

   Also, a front-end was included which could construct the, sometimes
painfully long, pipelines required for all the post- and preprocessors.

   Development of GNU `troff' progressed rapidly, and saw the additions
of a replacement for `refer', an implementation of the `ms' and `mm'
macros, and a program to deduce how to format a document (`grog').

   It was declared a stable (i.e. non-beta) package with the release of
version 1.04 around November 1991.

   Beginning in 1999, `groff' has new maintainers (the package was an
orphan for a few years).  As a result, new features and programs like
`grn', a preprocessor for gremlin images, and `grohtml', an output
device to produce HTML output, have been added.

`groff' Capabilities
====================

   So what exactly is `groff' capable of doing?  `groff' provides a
wide range of low-level text formatting operations.  Using these, it is
possible to perform a wide range of formatting tasks, such as
footnotes, table of contents, multiple columns, etc.  Here's a list of
the most important operations supported by `groff':

   * text filling, adjusting, and centering

   * hyphenation

   * page control

   * font and character size control

   * vertical spacing (i.e. double spacing)

   * line length and indenting

   * macros, strings, diversions, and traps

   * number registers

   * tabs, leaders, and fields

   * input and output conventions and character translation

   * overstrike, bracket, line drawing, and zero-width functions

   * local horizontal and vertical motions and the width function

   * three-part titles

   * output line numbering

   * conditional acceptance of input

   * environment switching

   * insertions from the standard input

   * input/output file switching

   * output and error messages

Macro Packages
==============

   Since `groff' provides such low-level facilities, it can be quite
difficult to use by itself.  However, `groff' provides a "macro"
facility to specify how certain routine operations (e.g. starting
paragraphs, printing headers and footers, etc.) should be done.  These
macros can be collected together into a "macro package".  There are a
number of macro packages available; the most common (and the ones
described in this manual) are `man', `mdoc', `me', `ms', and `mm'.

Preprocessors
=============

   Although `groff' provides most functions needed to format a
document, some operations would be unwieldy (e.g. to draw pictures).
Therefore, programs called preprocessors were written which understand
their own language and produce the necessary `groff' operations.  These
preprocessors are able to differentiate their own input from the rest
of the document via markers.

   To use a preprocessor, UNIX pipes are used to feed the output from
the preprocessor into `groff'.  Any number of preprocessors may be used
on a given document; in this case, the preprocessors are linked
together into one pipeline.  However, in `groff', the user does not
need to construct the pipe, but only tell `groff' what preprocessors to
use.

   `groff' currently has preprocessors for producing tables (`tbl'),
typesetting equations (`eqn'), drawing pictures (`pic' and `grn'), and
for processing bibliographies (`refer').  An associated program which
is useful when dealing with preprocessors is `soelim'.

   A free implementation of `grap', a preprocessor for drawing graphs,
can be obtained as an extra package; `groff' can use `grap' also.

   There are other preprocessors in existence, but, unfortunately, no
free implementations are available.  Among them are preprocessors for
drawing mathematical pictures (`ideal') and chemical structures
(`chem').

Output Devices
==============

   `groff' actually produces device independent code which may be fed
into a postprocessor which will produce output for a particular device.
Currently, `groff' has postprocessors for PostScript devices, character
terminals, X Windows (for previewing), TeX DVI format, HP LaserJet 4
and Canon LBP printers (which use CAPSL), and HTML.

Credits
=======

   Large portions of this manual were taken from existing documents,
most notably, the manual pages for the `groff' package by James Clark,
and Eric Allman's papers on the `me' macro package.

   The section on the `man' macro package is partly based on Susan G.
Kleinmann's `groff_man' manual page written for the Debian GNU/Linux
system.

Invoking `groff'
****************

   This section focuses on how to invoke the `groff' front end.  This
front end takes care of the details of constructing the pipeline among
the preprocessors, `gtroff' and the postprocessor.

   It has become a tradition that GNU programs get the prefix `g' to
distinguish it from its original counterparts provided by the host (see
Environment, for more details).  Thus, for example, `geqn' is
GNU `eqn'.  On operating systems like Linux or the Hurd, which don't
contain proprietary software, and on MS-DOS/MS-Windows, where `troff'
and associated programs are not available at all, this prefix is
omitted since GNU `troff' is the only used incarnation of `troff'.
Exception: `groff' is never replaced by `roff'.

Options
=======

   `groff' normally runs the `gtroff' program and a postprocessor
appropriate for the selected device.  The default device is `ps' (but
it can be changed when `groff' is configured and built).  It can
optionally preprocess with any of `gpic', `geqn', `gtbl', `ggrn',
`grap', `grefer', or `gsoelim'.

   This section only documents options to the `groff' front end.  Many
of the arguments to `groff' are passed on to `gtroff', therefore those
are also included.  Arguments to pre- or postprocessors can be found in
Invoking gpic, Invoking geqn, Invoking gtbl,
Invoking ggrn, Invoking grefer, Invoking gsoelim,
see Invoking grotty, Invoking grops,
Invoking grohtml, Invoking grodvi, Invoking grolj4,
Invoking grolbp, and Invoking gxditview.

   The command line format for `groff' is:

     groff [ -abeghilpstvzCEGNRSUVXZ ] [ -FDIR ] [ -mNAME ]
           [ -TDEF ] [ -fFAM ] [ -wNAME ] [ -WNAME ]
           [ -MDIR ] [ -dCS ] [ -rCN ] [ -nNUM ]
           [ -oLIST ] [ -PARG ] [ -LARG ] [ -IDIR ]
           [ FILES... ]

   The command line format for `gtroff' is as follows.

     gtroff [ -abivzCERU ] [ -wNAME ] [ -WNAME ] [ -dCS ]
            [ -fFAM ] [ -mNAME ] [ -nNUM ]
            [ -oLIST ] [ -rCN ] [ -TNAME ]
            [ -FDIR ] [ -MDIR ] [ FILES... ]

Obviously, many of the options to `groff' are actually passed on to
`gtroff'.

   Options without an argument can be grouped behind a single `-'.  A
filename of `-' denotes the standard input.  It is possible to have
whitespace between an option and its parameter.

   The `grog' command can be used to guess the correct `groff' command
to format a file.

   Here's the description of the command-line options:

`-h'
     Print a help message.

`-e'
     Preprocess with `geqn'.

`-t'
     Preprocess with `gtbl'.

`-g'
     Preprocess with `ggrn'.

`-G'
     Preprocess with `grap'.

`-p'
     Preprocess with `gpic'.

`-s'
     Preprocess with `gsoelim'.

`-R'
     Preprocess with `grefer'.  No mechanism is provided for passing
     arguments to `grefer' because most `grefer' options have
     equivalent commands which can be included in the file.  See
     grefer, for more details.

     Note that `gtroff' also accepts a `-R' option, which is not
     accessible via `groff'.  This option prevents the loading of the
     `troffrc' and `troffrc-end' files.

`-v'
     Make programs run by `groff' print out their version number.

`-V'
     Print the pipeline on stdout instead of executing it.

`-z'
     Suppress output from `gtroff'.  Only error messages will be
     printed.

`-Z'
     Do not postprocess the output of `gtroff'.  Normally `groff' will
     automatically run the appropriate postprocessor.

`-PARG'
     Pass ARG to the postprocessor.  Each argument should be passed
     with a separate `-P' option.  Note that `groff' does not prepend
     `-' to ARG before passing it to the postprocessor.

`-l'
     Send the output to a printer.  The command used for this is
     specified by the print command in the device description file.

`-LARG'
     Pass ARG to the spooler.  Each argument should be passed with a
     separate `-L' option.  Note that `groff' does not prepend a `-' to
     ARG before passing it to the postprocessor.

`-TDEV'
     Prepare output for device DEV.  The default device is `ps', unless
     changed when `groff' was configured and built.  The following are
     the output devices currently available:

    `ps'
          For PostScript printers and previewers.

    `dvi'
          For TeX DVI format.

    `X75'
          For a 75dpi X11 previewer.

    `X100'
          For a 100dpi X11 previewer.

    `ascii'
          For typewriter-like devices.

    `latin1'
          For typewriter-like devices that support the Latin-1
          (ISO 8859-1) character set.

    `utf8'
          For typewriter-like devices which use the Unicode (ISO 10646)
          character set with UTF-8 encoding.

    `cp1047'
          For typewriter-like devices which use the EBCDIC encoding IBM
          cp1047.

    `lj4'
          For an HP LaserJet4-compatible (or other PCL5-compatible)
          printer.

    `lbp'
          For Canon CAPSL printers (LBP-4 and LBP-8 series laser
          printers).

    `html'
          To produce HTML output.

     The predefined `gtroff' string register `.T' contains the current
     output device; the read-only number register `.T' is set to 1 if
     this option is used (which is always true if `groff' is used to
     call `gtroff').  See Built-in Registers.

     The postprocessor to be used for a device is specified by the
     `postpro' command in the device description file.  (see Font Files,
     for more info.)  This can be overridden with the `-X'
     option.

`-X'
     Preview with `gxditview' instead of using the usual postprocessor.
     This is unlikely to produce good results except with `-Tps'.

     Note that this is not the same as using `-TX75' or `-TX100' to
     view a document with `gxditview': The former will use the metrics
     of the specified device, whereas the latter will use X-specific
     fonts and metrics.

`-N'
     Don't allow newlines with `eqn' delimiters.  This is the same as
     the `-N' option in `geqn'.

`-S'
     Safer mode.  Pass the `-S' option to `gpic' and use the `-msafer'
     macros with `gtroff' (enabled by default).

`-U'
     Unsafe mode.  Reverts to the old unsafe behaviour.

`-a'
     Generate an ASCII approximation of the typeset output.  The
     read-only register `.A' is then set to 1.  See Built-in Registers.

`-b'
     Print a backtrace with each warning or error message.  This
     backtrace should help track down the cause of the error.  The line
     numbers given in the backtrace may not always be correct: `gtroff'
     can get confused by `as' or `am' requests while counting line
     numbers.

`-i'
     Read the standard input after all the named input files have been
     processed.

`-wNAME'
     Enable warning NAME.  Available warnings are described in
     Debugging.  Multiple `-w' options are allowed.

`-WNAME'
     Inhibit warning NAME.  Multiple `-W' options are allowed.

`-E'
     Inhibit all error messages.

`-C'
     Enable compatibility mode.  See Implementation Differences,
     for the list of incompatibilites between `groff' and traditional
     Unix `troff'.

`-dCS'
`-dNAME=s'
     Define C or NAME to be a string S.  C must be a one-letter name;
     NAME can be of arbitrary length.

`-fFAM'
     Use FAM as the default font family.

`-mNAME'
     Read in the file `tmac.NAME'.  Normally this will be searched for
     in the library directory of `groff'.

`-nNUM'
     Number the first page NUM.

`-oLIST'
     Output only pages in LIST, which is a comma-separated list of page
     ranges; `N' means print page N, `M-N' means print every page
     between M and N, `-N' means print every page up to N, `N-' means
     print every page beginning with N.  `gtroff' will exit after
     printing the last page in the list.  All the ranges are inclusive
     on both ends.

     Within `gtroff', this information can be extracted with the `.P'
     register.  See Built-in Registers.

`-rCN'
`-rNAME=N'
     Set number register C or NAME to the value N.  C must be a
     one-letter name; NAME can be of arbitrary length.  N can be any
     `gtroff' numeric expression.

`-FDIR'
     Search `DIR' for subdirectories `devNAME' (NAME is the name of the
     device), for the `DESC' file, and for font files before looking in
     the standard directory.

`-MDIR'
     Search directory `DIR' for macro files before the standard
     directory.

`-IDIR'
     This option is as described in gsoelim.  It implies the
     `-s' option.

Environment
===========

   There are also several environment variables (of the operating
system, not within `gtroff') which can modify the behavior of `groff'.

`GROFF_COMMAND_PREFIX'
     If this is set to X, then `groff' will run `Xtroff' instead of
     `gtroff'.  This also applies to `tbl', `pic', `eqn', `grn',
     `refer', and `soelim'.  It does not apply to `grops', `grodvi',
     `grotty', `grohtml', `grolj4', and `gxditview'.

`GROFF_TMAC_PATH'
     A colon-separated list of directories in which to search for macro
     files.

`GROFF_TYPESETTER'
     The default output device.

`GROFF_FONT_PATH'
     A colon-separated list of directories in which to search for the
     `dev'NAME directory.

`PATH'
     The search path for commands executed by `groff'.

`GROFF_TMPDIR'
     The directory in which temporary files will be created.  If this
     is not set and `TMPDIR' is set, temporary files will be created in
     that directory.  Otherwise temporary files will be created in a
     system-dependent default directory (on Unix and GNU/Linux systems,
     this is usually `/tmp').  The `grops' and `grefer' commands can
     create temporary files in this directory.

   Note that MS-DOS and MS-Windows ports of `groff' use semi-colons,
rather than colons, to separate the directories in the lists described
above.

Invocation Examples
===================

   This section will list several common uses of `groff' and the
command line which will accomplish it.

     groff file

This command processes `file' without a macro package or a
preprocessor.  The output device is the default, `ps', and the output
is sent to stdout.

     groff -t -mandoc -Tascii file | less

This is basically what a call to the `man' program does.  The manual
page `file' is processed with the `mandoc' macros (which in turn either
calls the `man' or the `mdoc' macro package), using the `tbl'
preprocessor and the ASCII output device.  Finally, the result is
displayed with the `less' pager.

     groff -X -m me file

Preview `file' with `gxditview', using the `me' macro package.  Since
no `-T' option is specified, use the default device (`ps').  Note that
you can either say `-m me' or `-me'; the latter is an anachronism from
the early days of UNIX.(1) (1)

     groff -man -rD1 -z file

Check `file' with the `man' macro package, forcing double-sided
printing - don't produce any output.

   (1) The same is true for the other main macro packages that come
with `groff': `man', `mdoc', `ms', `mm', and `mandoc'.  This won't work
in general; for example, to load `tmac.safer', either `-msafer' or
`-m safer' must be used.

`grog'
------

   `grog' reads files, guesses which of the `groff' preprocessors
and/or macro packages are required for formatting them, and prints the
`groff' command including those options on the standard output.  The
options generated are one of `-e', `-man', `-me', `-mm', `-ms', `-p',
`-R', `-g', `-G', `-s', and `-t'.

   A special file name `-' is taken to refer to the standard input.  If
no files are specified the standard input will be read.  Any specified
options will be included in the printed command.  No space is allowed
between options and their arguments.  For example,

     grog -Tdvi paper.ms

will guess the appropriate command to print `paper.ms' and then print
it to the command line after adding the `-Tdvi' option.  For direct
execution, enclose the call to `grog' in backquotes at the UNIX shell
prompt:

     `grog -Tdvi paper.ms` > paper.dvi

As seen in the example, it is still necessary to redirect the output to
something meaningful (i.e. either a file or a pager program like
`less').

Tutorial for Macro Users
************************

   Most users tend to use a macro package to format their papers.  This
means that the whole breadth of `groff' is not necessary for most
people.  This chapter covers the material needed to efficiently use a
macro package.

Basics
======

   This section covers some of the basic concepts necessary to
understand how to use a macro package.(1) (1)
References are made throughout to more detailed information, if desired.

   `gtroff' reads an input file prepared by the user and outputs a
formatted document suitable for publication or framing.  The input
consists of text, or words to be printed, and embedded commands
("requests" and "escapes"), which tell `gtroff' how to format the
output.  For more detail on this, see Embedded Commands.

   The word "argument" is used in this chapter to mean a word or number
which appears on the same line as a request, and which modifies the
meaning of that request.  For example, the request

     .sp

spaces one line, but

     .sp 4

spaces four lines.  The number 4 is an argument to the `sp' request
which says to space four lines instead of one.  Arguments are separated
from the request and from each other by spaces.  More details on this
can be found in Request Arguments.

   The primary function of `gtroff' is to collect words from input
lines, fill output lines with those words, justify the right-hand margin
by inserting extra spaces in the line, and output the result.  For
example, the input:

     Now is the time
     for all good men
     to come to the aid
     of their party.
     Four score and seven
     years ago,...

will be read, packed onto output lines, and justified to produce:

     Now is the time for all good men to come to the aid of their party.
     Four score and seven years ago,...

   Sometimes a new output line should be started even though the current
line is not yet full; for example, at the end of a paragraph.  To do
this it is possible to cause a "break", which starts a new output line.
Some requests cause a break automatically, as do blank input lines and
input lines beginning with a space.

   Not all input lines are text to be formatted.  Some of the input
lines are requests which describe how to format the text.  Requests
always have a period (`.') or an apostrophe (`'') as the first
character of the input line.

   The text formatter also does more complex things, such as
automatically numbering pages, skipping over page boundaries, putting
footnotes in the correct place, and so forth.

   Here are a few hints for preparing text for input to `gtroff'.
First, keep the input lines short.  Short input lines are easier to
edit, and `gtroff' will pack words onto longer lines anyhow.  In
keeping with this, it is helpful to begin a new line after every period,
comma, or phrase, since common corrections are to add or delete
sentences or phrases.  Secondly, do not hyphenate words at the end of
lines - `gtroff' is smart enough to hyphenate words for the user as
needed, but is not smart enough to take hyphens out and join a word
back together.  Also, words such as "mother-in-law" should not be
broken over a line, since then a space can occur where not wanted, such
as "mother- in-law".

   `gtroff' will double space output text automatically if you use the
request `.ls 2'.  Single spaced mode can be reactivated by typing
`.ls 1'.

   A number of requests allow to change the way the output looks,
sometimes called the "layout" of the output page.  Most of these
requests adjust the placing of "white space" (blank lines or spaces).

   The `.bp' request starts a new page, causing a line break.

   The request `.sp N' leaves N lines of blank space.  N can be omitted
(meaning skip a single line) or can be of the form Ni (for N inches) or
Nc (for N centimeters).  For example, the input:

     .sp 1.5i
     My thoughts on the subject
     .sp

leaves one and a half inches of space, followed by the line "My
thoughts on the subject", followed by a single blank line.

   Text lines can be centered by using the `ce' request.  The line
after `ce' is centered (horizontally) on the page.  To center more than
one line, use `.ce N' (where N is the number of lines to center),
followed by the N lines.  To center many lines without counting them,
type:

     .ce 1000
     lines to center
     .ce 0

The `.ce 0' request tells `groff' to center zero more lines, in other
words, stop centering.

   All of these requests cause a break; that is, they always start a new
line.  To start a new line without performing any other action, use
`br'.

   (1) This section is derived from `Writing Papers with nroff using
-me' by Eric P. Allman.

Common Features
===============

   `gtroff' provides very low level operations for formatting a
document.  There are many common routine operations which are done in
all documents.  These common operations are written into "macros" and
collected into a "macro package".

   All macro packages provide certain common capabilities which fall
into the following categories.

Paragraphs
----------

   One of the most common and most used capability is starting a
paragraph.  There are a number of different types of paragraphs, any of
which can be initiated with macros supplied by the macro package.
Normally, paragraphs start with a blank line and the first line
indented, like the text in this manual.  There are also block style
paragraphs, which omit the indentation:

     Some   men  look   at  constitutions   with  sanctimonious
     reverence, and deem them like the ark of the covenant, too
     sacred to be touched.

And there are also indented paragraphs which begin with a tag or label
at the margin and the remaining text indented.

     one   This is  the first paragraph.  Notice  how the first
           line of  the resulting  paragraph lines up  with the
           other lines in the paragraph.
     longlabel
           This  paragraph   had  a  long   label.   The  first
           character of text on the first line will not line up
           with  the  text  on  second  and  subsequent  lines,
           although they will line up with each other.

   A variation of this is a bulleted list.

Sections and Chapters
---------------------

   Most macro packages supply some form of section headers.  The
simplest kind is simply the heading on a line by itself in bold type.
Others supply automatically numbered section heading or different
heading styles at different levels.  Some, more sophisticated, macro
packages supply macros for starting chapters and appendices.

Headers and Footers
-------------------

   Every macro package gives some way to manipulate the headers and
footers (or "titles") on each page.  Some packages will allow for
different ones on the even and odd pages (for material printed in a book
form).

   The titles are called three-part titles, that is, there is a
left-justified part, a centered part, and a right-justified part.  An
automatically generated page number may be put in any of these fields
with the `%' character (see Page Layout, for more details).

Page Layout
-----------

   Most macro packages let the user specify top and bottom margins and
other details about the appearance of the printed pages.

Displays
--------

   Displays are sections of text to be set off from the body of the
paper.  Major quotes, tables, and figures are types of displays, as are
all the examples used in this document.

   "Major quotes" are quotes which are several lines long, and hence
are set in from the rest of the text without quote marks around them.

   A "list" is an indented, single spaced, unfilled display.  Lists
should be used when the material to be printed should not be filled and
justified like normal text, such as columns of figures or the examples
used in this paper.

   A "keep" is a display of lines which are kept on a single page if
possible.  An example for a keep might be a diagram.  Keeps differ from
lists in that lists may be broken over a page boundary whereas keeps
will not.

   Floating keeps move relative to the text.  Hence, they are good for
things which will be referred to by name, such as "See figure 3".  A
floating keep will appear at the bottom of the current page if it will
fit; otherwise, it will appear at the top of the next page.  Meanwhile,
the surrounding text will `flow' around the keep, thus leaving now blank
areas.

Footnotes and Annotations
-------------------------

   There are a number of requests to save text for later printing.

   "Footnotes" are printed at the bottom of the current page.

   "Delayed text" is very similar to a footnote except that it is
printed when called for explicitly.  This allows a list of references to
appear (for example) at the end of each chapter, as is the convention in
some disciplines.

   Most macro packages which supply this functionality also supply a
means of automatically numbering either type of annotation.

Table of Contents
-----------------

   "Tables of contents" are a type of delayed text having a tag
(usually the page number) attached to each entry after a row of dots.
The table accumulates throughout the paper until printed, usually after
the paper has ended.  Many macro packages will provide the ability to
have several tables of contents (i.e. one standard one, one for tables,
etc).

Indices
-------

   While some macro packages will use the term "index", none actually
provide that functionality.  The facilities they call indices are
actually more appropriate for tables of contents.

Paper Formats
-------------

   Some macro packages provide stock formats for various kinds of
documents.  Many of them provide a common format for the title and
opening pages of a technical paper.  The `mm' macros in particular
provide formats for letters and memoranda.

Multiple Columns
----------------

   Some macro packages (but not `man') provide the ability to have two
or more columns on a page.

Font and Size Changes
---------------------

   The built-in font and size functions are not always intuitive, so all
macro packages provide macros to make these operations simpler.

Predefined Strings
------------------

   Most macro packages provide various predefined strings for a variety
of uses; examples are sub- and superscripts, printable dates, quotes and
various special characters.

Preprocessor Support
--------------------

   All macro packages provide support for the various preprocessors.

Configuration and Customization
-------------------------------

   Some macro packages provide means of customizing many of the details
of how the package behaves.  This ranges from setting the default type
size to changing the appearance of section headers.

Macro Packages
**************

   This chapter documents the main macro packages that come with
`groff'.

`man'
=====

   This is the most popular and probably the most important macro
package of `groff'.  It is easy to use, and a vast majority of manual
pages are based on it.

Options
-------

   The command line format for using the `man' macros with `groff' is:

     groff -m man [ -rC1 ] [ -rD1 ] [ -rPNNN ] [ -rSXX ]
           [ -rXNNN ] [ FILES... ]

   It is possible to use `-man' instead of `-m man'.

`-rC1'
     If more than one manual page is given on the command line, number
     the pages continuously, rather than starting each at 1.

`-rD1'
     Double-sided printing.  Footers for even and odd pages are
     formatted differently.

`-rPNNN'
     Enumeration of pages will start with NNN rather than with 1.

`-rSXX'
     Use XX (which can be 10, 11, or 12pt) as the base document font
     size instead of the default value of 10pt.

`-rXNNN'
     After page NNN, number pages as NNNa, NNNb, NNNc, etc.  For
     example, the option `-rX2' will produce the following page
     numbers: 1, 2, 2a, 2b, 2c, etc.

Usage
-----

   This section describes the available macros for manual pages.  For
further customization, put additional macros and requests into the file
`man.local' which will be loaded immediately after `tmac.an'.

 - Macro: TH title section [EXTRA1] [EXTRA2] [EXTRA3]
     Sets the title of the man page to TITLE and the section to
     SECTION, which must have a value between 1 and 8.  The value of
     SECTION may also have a string appended, e.g. `.pm', to indicate a
     specific subsection of the man pages.

     Both TITLE and SECTION are positioned at the left and right in the
     header line (with SECTION in parentheses immediately appended to
     TITLE.  EXTRA1 will be positioned in the middle of the footer
     line.  EXTRA2 will be positioned at the left in the footer line
     (resp. at the left on even pages and at the right on odd pages if
     double-sided printing is active).  EXTRA3 is centered in the
     header line.

     For HTML output, headers and footers are completely suppressed.

     Additionally, this macro starts a new page; the new line number
     is 1 again (except if the `-rC1' option is given on the command
     line) - this feature is intended only for formatting multiple man
     pages; a single man page should contain exactly one `TH' macro at
     the beginning of the file.

 - Macro: SH [HEADING]
     Sets up an unnumbered section heading sticking out to the left.
     Prints out all the text following `SH' up to the end of the line
     (resp.  the text in the next line if there is no argument to `SH')
     in bold face, one size larger than the base document size.
     Additionally, the left margin for the following text is reset to
     its default value.

 - Macro: SS [HEADING]
     Sets up an unnumbered section heading.  Prints out all the text
     following `SS' up to the end of the line (resp. the text in the
     next line if there is no argument to `SS') in bold face, at the
     same size as the base document size.  Additionally, the left
     margin for the following text is reset to its default value.

 - Macro: TP [NNN]
     Sets up an indented paragraph with label.  The indentation is set
     to NNN if that argument is supplied (the default unit is `n' if
     omitted), otherwise it is set to the default indentation value.

     The first line of text following this macro is interpreted as a
     string to be printed flush-left, as it is appropriate for a label.
     It is not interpreted as part of a paragraph, so there is no
     attempt to fill the first line with text from the following input
     lines.  Nevertheless, if the label is not as wide as the
     indentation, then the paragraph starts at the same line (but
     indented), continuing on the following lines.  If the label is
     wider than the indentation, then the descriptive part of the
     paragraph begins on the line following the label, entirely
     indented.  Note that neither font shape nor font size of the label
     is set to a default value; on the other hand, the rest of the text
     will have default font settings.

 - Macro: LP
 - Macro: PP
 - Macro: P
     These macros are mutual aliases.  Any of them causes a line break
     at the current position, followed by a vertical space downwards by
     the amount specified by the `PD' macro.  The font size and shape
     are reset to the default value (10pt resp. Roman).  Finally, the
     current left margin is restored.

 - Macro: IP [DESIGNATOR] [NNN]
     Sets up an indented paragraph, using DESIGNATOR as a tag to mark
     its beginning.  The indentation is set to NNN if that argument is
     supplied (default unit is `n'), otherwise the default indentation
     value is used.  Font size and face of the paragraph (but not the
     designator) are reset to their default values.  To start an
     indented paragraph with a particular indentation but without a
     designator, use `""' (two double quotes) as the first argument of
     `IP'.

     For example, to start a paragraph with bullets as the designator
     and 4en indentation, write

          .IP \(bu 4

 - Macro: HP [NNN]
     Sets up a paragraph with hanging left indentation.  The
     indentation is set to NNN if that argument is supplied (default
     unit is `n'), otherwise the default indentation value is used.
     Font size and face are reset to their default values.

 - Macro: RS [NNN]
     This macro moves the left margin to the right by the value NNN if
     specified (default unit is `n'); otherwise the default indentation
     value is used.  Calls to the `RS' macro can be nested.

 - Macro: RE [NNN]
     This macro moves the left margin back to level NNN; if no argument
     is given, it moves one level back.  The first level (i.e., no call
     to `RS' yet) has number 1, and each call to `RS' increases the
     level by 1.

   To summarize, the following macros cause a line break with the
insertion of vertical space (which amount can be changed with the `PD'
macro): `SH', `SS', `TP', `LP' (`PP', `P'), `IP', and `HP'.

   The macros `RS' and `RE' also cause a break but do not insert
vertical space.

Macros to set fonts
-------------------

   The standard font is Roman; the default text size is 10 point.

 - Macro: SM [TEXT]
     Causes the text on the same line or the text on the next line to
     appear in a font that is one point size smaller than the default
     font.

 - Macro: SB [TEXT]
     Causes the text on the same line or the text on the next line to
     appear in boldface font, one point size smaller than the default
     font.

 - Macro: BI text
     Causes text on the same line to appear alternately in bold face and
     italic.  The text must be on the same line as the macro call.
     Thus,

          .BI this "word and" that

     would cause "this" and "that" to appear in bold face, while "word
     and" appears in italics.

 - Macro: IB text
     Causes text to appear alternately in italic and bold face.  The
     text must be on the same line as the macro call.

 - Macro: RI text
     Causes text on the same line to appear alternately in roman and
     italic.  The text must be on the same line as the macro call.

 - Macro: IR text
     Causes text on the same line to appear alternately in italic and
     roman.  The text must be on the same line as the macro call.

 - Macro: BR text
     Causes text on the same line to appear alternately in bold face and
     roman.  The text must be on the same line as the macro call.

 - Macro: RB text
     Causes text on the same line to appear alternately in roman and
     bold face.  The text must be on the same line as the macro call.

 - Macro: R [TEXT]
     Causes TEXT to appear in roman font.  If no text is present on the
     line where the macro is called, then the text of the next line
     appears in roman.  This is the default font to which text is
     returned at the end of processing of the other macros.

 - Macro: B [TEXT]
     Causes TEXT to appear in bold face.  If no text is present on the
     line where the macro is called, then the text of the next line
     appears in bold face.

 - Macro: I [TEXT]
     Causes TEXT to appear in italic.  If no text is present on the
     line where the macro is called, then the text of the next line
     appears in italic.

Miscellaneous
-------------

   The default indentation is 7.2n for all output devices except for
`grohtml' which uses 1.2i instead.

 - Macro: DT
     Sets tabs every 0.5 inches.  Since this macro is always called
     during a `TH' request, it makes sense to call it only if the tab
     positions have been changed.

 - Macro: PD [NNN]
     Adjusts the empty space before a new paragraph (resp. section).
     The optional argument gives the amount of space (default units are
     `v'); without parameter, the value is reset to its default value
     (1 line for tty devices, 0.4v otherwise).

   This affects the macros `SH', `SS', `TP', `LP' (resp. `PP' and `P'),
`IP', and `HP'.

   The following strings are defined:

 - Macro: \*S
     Switch back to the default font size.

 - Macro: \*R
     The `registered' sign.

 - Macro: \*(Tm
     The `trademark' sign.

 - Macro: \*(lq
 - Macro: \*(rq
     Left and right quote.  This is equal to `\(lq' and `\(rq',
     respectively.

   If a preprocessor like `gtbl' or `geqn' is needed, it has become
common usage to make the first line of the man page look like this:

     .\" WORD

   Note the single space character after the double quote.  WORD
consists of letters for the needed preprocessors: `e' for `geqn', `r'
for `grefer', `t' for `gtbl'.  Modern implementations of the `man'
program read this first line and automatically call the right
preprocessor(s).

`mdoc'
======

`ms'
====

`me'
====

`mm'
====

Programming Tutorial
********************

   This chapter covers *all* of the facilities of `gtroff'.  Users of
macro packages may skip it if not interested in details.

Text
====

   `gtroff' input files contain text with control commands interspersed
throughout.  But, even without control codes, `gtroff' will still do
several things with the input text: filling and adjusting, adding
additional space after sentences, hyphenating and inserting implicit
line breaks.

Filling and Adjusting
---------------------

   When `gtroff' reads in text it collects words from input and fits as
many of them together on one output line as it can.  This is known as
"filling".

   Once `gtroff' has a "filled" line it will try to "adjust" it.  This
means it will widen the spacing between words until the text reaches
the right margin (in the default adjustment mode).  Extra spaces
between words are preserved, but spaces at the end of lines are ignored.
Spaces at the front of a line will cause a "break" (breaks will be
explained in Implicit Line Breaks)

   See Manipulating Filling and Adjusting.

Hyphenation
-----------

   Since the odds are not great for finding a set of words, for every
output line, which will fit nicely on a line without inserting excessive
amounts of space between words, `gtroff' will hyphenate words so that
lines can be justified without there being too much space between
words.  It uses an internal hyphenation algorithm (a simplified version
of the algorithm used within TeX) to indicate which words can be
hyphenated and how to do so.  When a word is hyphenated the first part
of the word will be added to the current filled line being output (with
an attached hyphen), and the other portion will be added to the next
line to be filled.

   See Manipulating Hyphenation.

Sentences
---------

   Although it is often debated, some typesetting rules say there
should be different amounts of space after various punctuation marks.
For example, the `Chicago typsetting manual' says that a period at the
end of a sentence should have twice as much space following it as would
a comma or a period as part of an abbreviation.

   `gtroff' does this by flagging certain characters (normally `!', `?'
and `.') as "end of sentence" characters.  When `gtroff' encounters one
of these characters at the end of a line it will append two "sentence
spaces" in the formatted output.  (This justifies one of the
conventions mentioned in Input Conventions.)

   In addition, the following characters resp. glyphs are treated
transparently while handling end of sentence characters: `"', `'', `)',
`]', `*', `dg', and `rq'.

   See the `cflags' request in Using Symbols, for more details.

   To prevent the insertion of extra space after an end of sentence
character (at the end of a line), append `\&'.

Tab Stops
---------

   `gtroff' translates "tabulator characters", also called "tabs"
(normally code point ASCII `0x09' resp.  EBCDIC `0x05'), in the input
into movements to the next tabulator stop.  These tab stops are
initially located every half inch across the page.  Using this, simple
tables can easily be made.  However, it can often be deceptive as the
appearance (and width) of the text on a terminal and the results from
`gtroff' can vary greatly.

   Also, a possible sticking point is that lines beginning with tab
characters will still be filled, again producing unexpected results.
For example, the following input

           1          2          3
                      4          5

will produce

           1          2          3                     4          5

   See Tabs and Fields.

Implicit Line Breaks
--------------------

   An important concept in `gtroff' is the "break".  When a break
occurs, `gtroff' will output the partially filled line (unjustified),
and resume collecting and filling text on the next output line.

   There are several ways to cause a break in `gtroff'.  A blank line
will not only cause a break, but it will also cause a one line vertical
space (effectively a blank line) to be output.

   A line which begins with a space will cause a break and the space
will be output at the beginning of the next line.  Note that this space
isn't adjusted, even in fill mode.

   The end of file will also cause a break - otherwise the last line of
the document may vanish!

   Certain requests also cause breaks, implicitly or explicitly.  This
will be discussed in Manipulating Filling and Adjusting.

Input Conventions
=================

   Since `gtroff' does filling automatically, it is traditional in
`groff' not to try and type things in as nicely formatted paragraphs.
These are some conventions commonly used when typing `gtroff' text:

   * Break lines after punctuation, particularly at the end of a
     sentence, and in other logical places.  Keep separate phrases on
     lines by themselves, as entire phrases are often added or deleted
     when editing.

   * Try to keep lines less than 40-60 characters, to allow space for
     inserting more text.

   * Do not try to do any formatting in a WYSIWYG manner (i.e., don't
     try and use spaces to get proper indentation).

Measurements
============

   `gtroff' (like any other programs) requires numeric parameters to
specify various measurements.  Most numeric parameters(1) (
1) may have a "measurement unit" attached.
These units are specified as a single character which immediately
follows the number or expression.  Each of these units are understood,
by `gtroff', to be a multiple of its "basic unit".  So, whenever a
different measurement unit is specified `gtroff' converts this into its
"basic units".  This basic unit, represented by a `u', is a device
dependent measurement which is quite small, ranging from 1/75th to
1/72000th of an inch.  The values may be given as fractional numbers;
however, fractional basic units are always rounded to integers.

   Some of the measurement units are completely independent of any of
the current settings (e.g. type size) of `gtroff'.

`i'
     Inches.  An antiquated measurement unit still in use in certain
     backwards countries.  One inch is equal to 2.54cm.

`c'
     Centimeters.  One centimeter is equal to 0.3937in.

`p'
     Points.  This is a typesetter's measurement used for measure type
     size.  It is 72 points to an inch.

`P'
     Pica.  Another typesetting measurement.  6 Picas to an inch (and
     12 points to a pica).

`s'
`z'
     See Fractional Type Sizes, for a discussion of these units.

   The other measurements understood by `gtroff' are dependent on
settings currently in effect in `gtroff'.  These are very useful for
specifying measurements which should look proper with any size of text.

`m'
     Ems.  This unit is equal to the current font size in points.  So
     called because it is _approximately_ the width of the letter `m'
     in the current font.

`n'
     Ens.  This is half of an em.

`v'
     Vertical space.  This is equivalent to the current line spacing.
     See Sizes, for more information about this.

`M'
     100ths of an em.

   (1) those that specify vertical or horizontal motion or a type size

Default Units
-------------

   Many requests take a default unit.  While this can be helpful at
times, it can cause strange errors in some expressions.  For example,
the line length request expects em units.  Here are several attempts to
get a line length of 3.5 inches and their results:

     3.5i      =>   3.5i
     7/2       =>   0i
     7/2i      =>   0i
     7i/2      =>   0.1i
     7i/2u     =>   3.5i

Everything will be converted to basic units first.  In the above example
it is assumed that 1i equals 240u, and 1m equals 10p (thus 1m
equals 33u).  The value 7i/2 will be first handled as 7i/2m, then
converted to 1680u/66u which is 25u, and this is approximately 0.1i.

   As a conclusion, the safest way to specify measurements is to always
attach a scaling indicator.  If you want to multiply or divide by a
certain scalar value, use `u' as the unit for that value.

Expressions
===========

   `gtroff' has most of operators common to other languages:

   * Arithmetic: `+' (addition), `-' (subtraction), `/' (division), `*'
     (multiplication), `%' (modulo).

     `gtroff' only provides integer arithmetic.  The internal type used
     for computing results is `int', which is usually a 32bit signed
     integer.

   * Comparison: `<' (less than), `>' (greater than), `<=' (less than
     or equal), `>=' (greater than or equal), `=' (equal), `==' (the
     same as `=').

   * Logical: `&' (logical and), `:' (logical or).

   * Unary operators: `-' (negating, i.e. changing the sign), `+' (just
     for completeness; does nothing in expressions), `!' (logical not;
     this works only within `if' and `while' requests).  See below for
     the use of unary operators in motion requests.

   * Extrema: `>?' (maximum), `<?' (minimum).  For example, `5>?3'
     yields `5'.

   * Scaling: `(C;E)'.  Evaluate E using C as the default scaling
     indicator.  If C is missing, ignore scaling indicators in the
     evaluation of E.

   Parentheses may be used as in any other language.  However, in
`gtroff' they are necessary to ensure order of evaluation.  `gtroff'
has no operator precedence; expressions are evaluated left to right.
This means that `3+5*4' is evaluated as if it were parenthesized like
`(3+5)*4', not as `3+(5*4)', as might be expected.

   For many requests which cause a motion on the page, the unary
operators work differently.  The `+' and `-' operators then indicate a
motion relative to the current position (down or up, respectively), and
the `|' operator indicates an absolute position on the page or input
line.  `+' and `-' are also treated differently by the following
requests and escapes: `bp', `in', `ll', `lt', `nm', `nr', `pl', `pn',
`po', `ps', `rt', `ti', `\R', and `\s'.  Here the plus and minus signs
indicate increments resp. decrements.

   See Setting Registers.

   Due to the way arguments are parsed, spaces are not allowed in
expressions, unless the entire expression is surrounded by parentheses.

   See Request Arguments, and Conditionals and Loops.

Identifiers
===========

   Like any other language, `gtroff' has rules for properly formed
"identifiers".  In `gtroff', an identifier can be made up of almost any
printable character, with the exception of the following characters:

   * Whitespace characters (space, tabs, and newlines).

   * Backspace (ASCII `0x08' resp. EBCDIC `0x16') and character code
     `0x01'.

   * The following input characters are invalid and will be ignored if
     `groff' runs on a machine based on ASCII, causing a warning
     message of type `input' (see Debugging, for more details):
     `0x00', `0x0B', `0x0D'-`0x1F', `0x80'-`0x9F'.

     And here are the invalid input characters if `groff' runs on an
     EBCDIC host: `0x00', `0x08', `0x09', `0x0B', `0x0D'-`0x14',
     `0x17'-`0x1F', `0x30'-`0x3F'.

     Currently, some of these reserved codepoints are used internally,
     thus making it non-trivial to extend `gtroff' to cover Unicode or
     other character sets resp. encodings which use characters of these
     ranges.

     Note that invalid characters will be removed before parsing; an
     identifier `foo', followed by an invalid character, followed by
     `bar' will be treated as `foobar'.

   For example, any of the following is valid.

     br
     PP
     (l
     end-list
     @_

   Note that identifiers longer than two characters with a closing
bracket (`]') in its name can't be accessed with escape sequences which
expect an identifier as a parameter.  For example, `\[foo]]' will
access the glyph `foo', followed by `]', whereas `\C'foo]'' really asks
for glyph `foo]'.

 - Escape: \A ident
     Whether an identifier IDENT is valid in `gtroff' can be tested
     with the `\A' escape.  It expands to the character 1 or 0
     according to whether its argument (usually delimited by quotes) is
     or is not acceptable as the name of a string, macro, diversion,
     number register, environment, or font.  It will return 0 if no
     argument is given.  This is useful for looking up user input in
     some sort of associative table.

          \A'end-list'
              => 1

   See Escapes, for details on parameter delimiting characters.

   Identifiers in `gtroff' can be any length, but, in some contexts,
`gtroff' needs to be told where identifiers end and text begins (and in
different ways depending on their length):

   * Single character.

   * Two characters.  Must be prefixed with `(' in some situations.

   * Arbitrary length (`gtroff' only).  Must be bracketed with `['
     and `]' in some situations.  Any length identifier can be put in
     brackets.

   Unlike many other programming languages, undefined identifiers are
silently ignored or expanded to nothing.

   See Interpolating Registers, and Strings.

Embedded Commands
=================

   Most documents need more functionality beyond filling, adjusting and
implicit line breaking.  In order to gain further functionality,
`gtroff' allows commands to be embedded into the text, in two ways.

   The first is a "request" which takes up an entire line, and does
some large scale operation (e.g. break lines, start new pages).

   The other is an "escape" which can be embedded anywhere in the text,
or even as an argument to a request.  Escapes generally do more minor
operations like sub- and superscripts, print a symbol, etc.

Requests
--------

   A request line begins with a control character, which is either a
single quote (`'', the "no-break control character") or a period (`.',
the normal "control character").  These can be changed; see
Character Translations, for details.  After this there may be
optional tabs or spaces followed by an identifier which is the name of
the request.  This may be followed by any number of space-separated
arguments.

   To begin a line with a control character without it being
interpreted, precede it with `\&'.  This represents a zero width space,
which means it will not affect the output.

   In most cases the period is used as a control character.  Several
requests will cause a break implicitly; using the single quote control
character will prevent this.

Request Arguments
.................

   Arguments to requests (and macros) are processed much like the shell:
The line is split into arguments according to spaces.  An argument which
is intended to contain spaces can either be enclosed in quotes (single
or double), or have the spaces "escaped" with backslashes.

   Here are a few examples:

     .uh The Mouse Problem
     .uh "The Mouse Problem"
     .uh The\ Mouse\ Problem

The first line is the `uh' macro being called with 3 arguments, `The',
`Mouse', and `Problem'.  The latter two have the same effect or calling
the `uh' macro with one argument, `The Mouse Problem'.(1) (
1)

   Note, however, that the `ds' request works differently.  See
Strings, for more details.

   (1) The last solution, i.e., using escaped spaces, is "classical" in
the sense that it can be found in most `troff' documents.
Nevertheless, it is not optimal in all situations, since `\ ' inserts a
fixed-width, non-breaking space character which can't stretch.
`gtroff' provides a different command `\~' to insert a stretchable,
non-breaking space.

Macros
------

   `gtroff' has a "macro" facility for defining a series of lines which
can be invoked by name.  They are called in the same manner as requests
- arguments also may be passed in the same manner.

   See Writing Macros, and Request Arguments.

Escapes
-------

   Escapes may occur anywhere in the input to `gtroff'.  They usually
begin with a backslash and are followed by a single character which
indicates the function to be performed.  The escape character can be
changed; see Character Translations.

   Escape sequences which require an identifier as a parameter accept
three possible syntax forms.

   * The next single character is the identifier.

   * If this single character is an opening parenthesis, take the
     following two characters as the identifier.  Note that there is no
     closing parenthesis after the identifier.

   * If this single character is an opening bracket, take all characters
     until a closing bracket as the identifier.

Examples:

     \fB
     \n(XX
     \*[TeX]

   Other escapes may require several arguments and/or some special
format.  In such cases the argument is traditionally enclosed in single
quotes (and quotes are always used in this manual for the definitions
of escape sequences).  The enclosed text is then processed according to
what that escape expects.  Example:

     \l'1.5i\(bu'

   Note that the quote character can be replaced with any other
character which does not occur in the argument (even a newline or a
space character) in the following escapes: `\o', `\b', and `\X'.  This
makes e.g.

     A caf
     \o
     e\'

     in Paris
       => A cafe' in Paris

possible, but it is better not to use this feature to avoid confusion.

   The following escapes sequences (which are handled similarly to
characters since they don't take a parameter) are also allowed as
delimiters: `\%', `\ ', `\|', `\^', `\{', `\}', `\'', `\`', `\-', `\_',
`\!', `\?', `\@', `\)', `\/', `\,', `\&', `\~', `\0', `\a', `\c', `\d',
`\e', `\E', `\p', `\r', `\t', and `\u'.  Again, don't use these if
possible.

   No newline characters as delimiters are allowed in the following
escapes: `\A', `\Z', `\C', and `\w'.

   Finally, the escapes `\D', `\h', `\H', `\l', `\L', `\N', `\R', `\s',
`\S', `\v', and `\x' can't use the following characters as delimiters:

   * The digits `0'-`9'.

   * The (single-character) operators `+-/*%<>=&:().'.

   * The space, tab, and newline characters.

   * All escape sequences except `\%', `\{', `\}', `\'', `\`', `\-',
     `\_', `\!', `\@', `\/', `\c', `\e', and `\p'.

   To have a backslash (resp. the current escape character) appear in
the output several escapes are defined: `\\', `\e' or `\E'.  These are
very similar, and only differ with respect to being used in macros or
diversions.  See Copy-in Mode, and Diversions, for more
information.

   See Identifiers, and Character Translations.

Comments
........

   Probably one of the most(1) (1) common
forms of escapes is the comment.

 - Escape: \"
     Start a comment.  Everything to the end of the input line is
     ignored.

     This may sound simple, but it can be tricky to keep the comments
     from interfering with the appearance of the final output.

     If the escape is to the right of some text or a request, that
     portion of the line will be ignored, but the space leading up to
     it will be noticed by `gtroff'.  This only affects the `.ds'
     request.

     One possibly irritating idiosyncracy is that tabs must not be used
     to line up comments.  Tabs are not treated as white space between
     the request and macro arguments.

     A comment on a line by itself will be treated as a blank line,
     because after eliminating the comment, that is all that remains:

          Test
          \" comment
          Test

     will produce

          Test

          Test

     As a consequence, it is common to start the line with `.\"' which
     will cause the line to be treated as an undefined request and thus
     ignored completely.

     Another commenting scheme seen sometimes is three consecutive
     single quotes (`'''') at the beginning of a line.  This works, but
     `gtroff' will give a warning about an undefined macro (namely
     `'''), which is harmless, but irritating.

 - Escape: \#
     To avoid all this, `gtroff' has a new comment mechanism using the
     `\#' escape.  This escape works the same as `\"' except that the
     newline is also ignored:

          Test
          \# comment
          Test

     will produce

          Test Test

     as expected.

   For commenting away large blocks of text, the `ig' request may be
useful.

   See Strings.

   (1) Unfortunately, this is a lie.  But hopefully future `gtroff'
hackers will believe it `:-)'

Registers
=========

   Numeric variables in `gtroff' are called "registers".  There are a
number of built-in registers, supplying anything from the date to
details of formatting parameters.

   See Identifiers, for details on register identifiers.

Setting Registers
-----------------

   Registers are defined resp. set via the `nr' request or the `\R'
escape.

 - Request: nr ident value
 - Escape: \R ident value
     Set number register IDENT to VALUE.  If IDENT doesn't exist, it
     will be created.

     The argument to `\R' has to be enclosed in quotes usually.  See
     Escapes, for details on parameter delimiting characters.

   For example, the following two lines are equivalent:

     .nr a 1
     \R'a 1'

   Both `nr' and `\R' have two additional special forms to increment
resp. decrement a register.

 - Request: nr ident +value
 - Request: nr ident -value
 - Escape: \R ident +value
 - Escape: \R ident -value
     Increment (decrement) register IDENT by VALUE.

          .nr a 1
          .nr a +1
          \na
              => 2

     To assign the negated value of a register to another register,
     some care must be taken to get the desired result:

          .nr a 7
          .nr b 3
          .nr a -\nb
          \na
              => 4
          .nr a (-\nb)
          \na
              => -3

     The surrounding parentheses prevent the interpretation of the
     minus sign as a decrementing operator.  An alternative is to start
     the assignment with a `0':

          .nr a 7
          .nr b -3
          .nr a \nb
          \na
              => 4
          .nr a 0\nb
          \na
              => -3

 - Request: rr ident
     Remove number register IDENT.  If IDENT doesn't exist, the request
     is ignored.

 - Request: rnn ident1 ident2
     Rename number register IDENT1 to IDENT2.  If either IDENT1 or
     IDENT2 doesn't exist, the request is ignored.

 - Request: aln ident1 ident2
     This request creates an alias IDENT1 for a number register IDENT2.
     The new name and the old name will be exactly equivalent.  If
     IDENT1 is undefined, a warning of type `reg' will be generated,
     and the request will be ignored.  See Debugging, for
     information about warnings.

Interpolating Registers
-----------------------

   Numeric registers can be accessed via the `\n' escape.

 - Escape: \n ident
     Interpolate number register IDENT.  This means that the value of
     the register is expanded in-place while `gtroff' is parsing the
     input line.

          .nr a 5
          .nr as \na+\na
          \n(as
              => 10

Auto-increment
--------------

   Number registers can also be auto-incremented and auto-decremented.
The increment resp. decrement factor can be specified with a third
argument to the `nr' request or `\R' escape.

 - Request: nr ident value incr
     Set number register IDENT to VALUE; the increment for
     auto-incrementing is set to INCR.  Note that the `\R' escape
     doesn't support this notation.

   To activate auto-incrementing, the escape `\n' has a special syntax
form.

 - Escape: \n +ident
 - Escape: \n -ident
     Before interpolating, increment resp. decrement IDENT by the
     auto-increment value as specified with the `nr' request (or the
     `\R' escape).  If no auto-increment value has been specified, both
     syntax forms are identical to `\n'.

   For example,

     .nr a 0 1
     .nr xx 0 5
     .nr foo 0 -2
     \n+a, \n+a, \n+a, \n+a, \n+a
     .br
     \n-(xx, \n-(xx, \n-(xx, \n-(xx, \n-(xx
     .br
     \n+[foo], \n+[foo], \n+[foo], \n+[foo], \n+[foo]

produces

     1, 2, 3, 4, 5
     -5, -10, -15, -20, -25
     -2, -4, -6, -8, -10

   To change the increment value without changing the value of a
register, the following can be used:

     .nr a \na 10

Assigning Formats
-----------------

   When a register is used in the text of an input file (as opposed to
part of an expression), it is textually replaced (or interpolated) with
a representation of that number.  This output format can be changed to a
variety of formats (numbers, Roman numerals, etc.).  This is done using
the `af' request.

 - Request: af ident format
     Change the output format of a number register.  The first argument
     IDENT is the name of the number register to be changed, and the
     second argument FORMAT is the output format.  The following output
     formats are available:

    `1'
          Decimal arabic numbers.  This is the default format: 1, 2,
          3, ....

    `0...0'
          Decimal numbers with as many digits as specified.  So, `00'
          would result in printing numbers as 01, 02, 03, ....

          In fact, any digit instead of zero will do; `gtroff' only
          counts how many digits are specified.  As a consequence,
          `af''s default format `1' could be specified as `0' also (and
          exactly this is returned by the `\g' escape, see below).

    `I'
          Upper-case Roman numerals: 0, I, II, III, IV, ....

    `i'
          Lower-case Roman numerals: 0, i, ii, iii, iv, ....

    `A'
          Upper-case letters: A, B, C, ..., Z, AA, AB, ....

    `a'
          Lower-case letters: a, b, c, ..., z, aa, ab, ....

     Omitting the number register format will cause a warning of type
     `missing'.  See Debugging, for more details.  Specifying a
     nonexistent format causes an error.

     The following example will produce `10, X, j, 010':

          .nr a 10
          .af a 1           \" the default format
          \na,
          .af a I
          \na,
          .af a a
          \na,
          .af a 001
          \na

     The largest number representable for the `i' and `I' formats is
     39999 (resp. -39999); UNIX `troff' uses `z' and `w' to represent
     10000 and 5000 in Roman numerals, and so does `gtroff'.
     Currently, the correct glyphs of Roman numeral five thousand and
     Roman numeral ten thousand (Unicode code points `U+2182' and
     `U+2181', respectively) are not available.

     If IDENT doesn't exist, it will be created.

     Changing the output format of a read-only register causes an
     error.  It is necessary to first copy the register's value to a
     writeable register, then apply the `af' request to this other
     register.

 - Escape: \g ident
     Return the current format of the specified register IDENT.  For
     example, `\ga' after the previous example would produce the string
     `000'.  If the register hasn't been defined yet, nothing is
     returned.

Built-in Registers
------------------

   The following lists some built-in registers which are not described
elsewhere in this manual.  Any register which begins with a `.' is
read-only.  A complete listing of all built-in registers can be found in
Register Index.

`.H'
     Horizontal resolution in basic units.

`.V'
     Vertical resolution in basic units.

`dw'
     Day of the week (1-7).

`dy'
     Day of the month (1-31).

`mo'
     Current month (1-12).

`year'
     The current year.

`yr'
     The current year minus 1900.  Unfortunately, the documentation of
     UNIX Version 7's `troff' had a year 2000 bug: It incorrectly
     claimed that `yr' contains the last two digits of the year.  That
     claim has never been true of either traditional `troff' or GNU
     `troff'.  Old `troff' input that looks like this:

          '\" The following line stopped working after 1999
          This document was formatted in 19\n(yr.

     can be corrected as follows:

          This document was formatted in \n[year].

     or, to be portable to older `troff' versions, as follows:

          .nr y4 1900+\n(yr
          This document was formatted in \n(y4.

`.c'
`c.'
     The current _input_ line number.  Register `.c' is read-only,
     whereas `c.' (a `gtroff' extension) is writable also, affecting
     both `.c' and `c.'.

`ln'
     The current _output_ line number after a call to the `nm' request
     to activate line numbering.

`.x'
     The major version number.  For example, if the version number
     is 1.03 then `.x' will contain `1'.

`.y'
     The minor version number.  For example, if the version number
     is 1.03 then `.y' will contain `03'.

`.Y'
     The revision number of `groff'.

`.g'
     Always 1.  Macros should use this to determine whether they are
     running under GNU `troff'.

`.A'
     If the command line option `-a' is used to produce an ASCII
     approximation of the output, this is set to 1, zero otherwise.
     See Groff Options.

`.P'
     This register is set to 1 (and to 0 otherwise) if the current page
     is actually being printed, i.e., if the `-o' option is being used
     to only print selected pages.  See Groff Options, for more
     information.

`.T'
     If `gtroff' is called with the `-T' command line option, the
     number register `.T' is set to 1, and zero otherwise.  See Groff Options.

     Additionally, `gtroff' predefines a single (read/write) string
     register `.T' which contains the current output device (for
     example, `latin1' or `ps').

Manipulating Filling and Adjusting
==================================

   Various ways of causing "breaks" were given in Implicit Line Breaks.
The `br' request will likewise cause a break.  Several other
requests will also cause breaks, but implicitly.  These are `bp', `ce',
`cf', `fi', `fl', `in', `nf', `rj', `sp', `ti', and `trf'.

 - Request: br
     Break the current line, i.e., the input collected so far will be
     emitted without adjustment.

     If the no-break control character is used, no break will happen:

          a
          'br
          b
              => a b

   Initially, `gtroff' will fill and adjust text to both margins.
Filling can be disabled via the `nf' request and re-enabled with the
`fi' request.

 - Request: fi
     Activate fill mode (which is the default).  This request implicitly
     enables adjusting; it will also cause a break in the text currently
     being filled.  The number register `.u' is set to 1.

     The fill mode status is associated with the current environment
     (see Environments).

 - Request: nf
     Activate no-fill mode.  Input lines are output as-is, retaining
     line breaks.  The current line length will be ignored.  This
     command implicitly disables adjusting; it also causes a break.
     The number register `.u' will be set to 0.

     The fill mode status is associated with the current environment
     (see Environments).

 - Request: ad [MODE]
     Set adjusting mode.

     Activation and deactivation of adjusting will be implicitly done
     with calls to the `fi' resp. `nf' requests.

     MODE can have one of the following values:

    `l'
          Adjust text to the left margin.  This produces what is
          traditionally called ragged-right text.

    `r'
          Adjust text to the right margin, producing ragged-left text.

    `c'
          Center filled text.  This is different to the `ce' request
          which only centers text without filling.

    `b'
    `n'
          Justify to both margins.  This is the default used by
          `gtroff'.

     With no argument, `gtroff' will adjust lines in the same way it did
     before adjusting has been deactivated (with a call to `na', for
     example).

          text
          .ad r
          text
          .ad c
          text
          .na
          text
          .ad  \" back to centering
          text

     The current adjustment mode is available in the number register
     `.j'; it can be stored and subsequently used to set adjustment.

     The adjustment mode status is associated with the current
     environment (see Environments).

 - Request: na
     Disable adjusting.  This request won't change the current
     adjustment mode: A call to `ad' afterwards will use the previous
     adjustment setting.

     The adjustment mode status is associated with the current
     environment (see Environments).

 - Escape: \p
     Adjust the current line and cause a break.

     In most cases this will produce very ugly results, since `gtroff'
     doesn't have a sophisticated paragraph building algorithm (as TeX
     does, for example); instead, `gtroff' fills and adjusts a paragraph
     line by line:

            This is an uninteresting sentence.
            This is an uninteresting sentence.\p
            This is an uninteresting sentence.

     is formatted as

            This is  an uninteresting  sentence.   This  is an
            uninteresting                            sentence.
            This is an uninteresting sentence.

 - Request: ss word_space_size [SENTENCE_SPACE_SIZE]
     Change the minimum size of a space between filled words.  It takes
     its units as one twelfth of the space width parameter for the
     current font.  Initially both the WORD_SPACE_SIZE and
     SENTENCE_SPACE_SIZE are 12.

     If two arguments are given to the `ss' request, the second argument
     sets the sentence space size.  If the second argument is not given,
     sentence space size will be set to WORD_SPACE_SIZE.  The sentence
     space size is used in two circumstances: if the end of a sentence
     occurs at the end of a line in fill mode, then both an inter-word
     space and a sentence space will be added; if two spaces follow the
     end of a sentence in the middle of a line, then the second space
     will be a sentence space.  Note that the behaviour of UNIX `troff'
     will be exactly that exhibited by GNU `troff' if a second argument
     is never given to the `ss' request.  In GNU `troff', as in UNIX
     `troff', a sentence should always be followed by either a newline
     or two spaces.

     The number registers `.ss' and `.sss' hold the values of the
     parameters set by the first and second arguments of the `ss'
     request.

     The word space and sentence space values are associated with the
     current environment (see Environments).

     This request is ignored in nroff mode; it is also ignored if there
     is no parameter.

 - Request: ce [NNN]
     Center text.  While the `.ad c' request will also center text, it
     has the side effect of filling the text.  `ce' will not fill the
     text it affects.  This request causes a break.

     With no arguments, `ce' will center the next line of text.  NNN
     specifies the number of lines to be centered.  If the argument is
     zero or negative, centering is disabled.

     The basic length for centering text is the line length (as set
     with the `ll' request) minus the indentation (as set with the `in'
     request).  Temporary indentation is ignored.

     A common idiom is to turn on centering for a large number of
     lines, and to turn off centering after text to be centered.  This
     is useful for any request which takes a number of lines as an
     argument.

          .ce 1000
          replace this
          with
          something
          more interesting
          ...
          .ce 0

     The `.ce' number register contains the number of lines remaining to
     be centered, as set by the `ce' request.

 - Request: rj [NNN]
     Justify unfilled text to the right margin.  Arguments are
     identical to the `ce' request.  The `.rj' number register is the
     number of lines to be right-justified as set by the `rj' request.
     This request causes a line break.

Manipulating Hyphenation
========================

   As discussed in Hyphenation, `gtroff' will hyphenate words.
There are a number of ways to influence hyphenation.

 - Request: hy [MODE]
     Enable hyphenation.  The request has an optional numeric argument,
     MODE, to restrict hyphenation if necessary:

    `1'
          The default argument if MODE is omitted.  Hyphenate without
          restrictions.  This is also the start-up value of `gtroff'.

    `2'
          Do not hyphenate the last word on a page or column.

    `4'
          Do not hyphenate the last two characters of a word.

    `8'
          Do not hyphenate the first two characters of a word.

     Values in the previous table are additive.  For example, the
     value 12 causes `gtroff' to neither hyphenate the last two nor the
     first two characters of a word.

     The current hyphenation restrictions can be found in the number
     register `.hy'.

     The hyphenation mode is associated with the current environment
     (see Environments).

 - Request: nh
     Disable hyphenation (i.e., set the hyphenation mode to zero).
     Note that the hyphenation mode of the last call to `hy' is not
     remembered.

     The hyphenation mode is associated with the current environment
     (see Environments).

 - Request: hlm [NNN]
     Set the maximum number of consecutive hyphenated lines to NNN.  If
     this number is negative, there is no maximum.  The default value
     is -1 if NNN is omitted.  This value is associated with the current
     environment (see Environments).  Only lines output from a given
     environment count towards the maximum associated with that
     environment.  Hyphens resulting from `\%' are counted; explicit
     hyphens are not.

     The current setting of `hlm' is available in the `.hlm' register.
     Also the number of immediately preceding consecutive hyphenated
     lines are available in the number register `.hlc'.

 - Request: hw word1 word2 ...
     Define how WORD1, WORD2, etc. are to be hyphenated.  The words
     must be given with hyphens at the hyphenation points.  For example:

          .hw in-sa-lub-rious

     Besides the space character, any character whose hyphenation code
     value is zero can be used to separate the arguments of `hw' (see
     the documentation for the `hcode' request below for more
     information).  In addition, this request can be used more than
     once.

     Hyphenation exceptions specified with the `hw' request are
     associated with the current hyphenation language; it will cause an
     error if there is no current hyphenation language.

     This request is ignored if there is no parameter.

     In old versions of `troff' there was a limited amount of space to
     store such information; fortunately, with `gtroff', this is no
     longer a restriction.

 - Escape: \%
     To tell `gtroff' how to hyphenate words on the fly, the `\%'
     escape, also known as the "hyphenation character", can be used.
     Preceding a word with this character will prevent it from being
     hyphenated, putting it in a word will indicate to `gtroff' that the
     word may be hyphenated at that point.  Note that this mechanism
     will only affect that one occurrence of the word; to change the
     hyphenation of a word for the entire document, use the `hw'
     request.

 - Request: hc [CHAR]
     Change the hyphenation character to CHAR.  This character will
     then work the same as the `\%' escape, and thus, no longer appear
     in the output.  Without an argument, `hc' will reset the
     hyphenation character to be `\%' (the default) only.

     The hyphenation character is associated with the current
     environment (see Environments).

 - Request: hpf pattern_file
     Read in a file of hyphenation patterns.  This file will be
     searched for in the same way as `tmac.NAME' is searched for if the
     `-mNAME' option is specified.

     It should have the same format as the argument to the `\patterns'
     primitive in TeX (without using TeX's macro expansion); the
     letters appearing in this file are interpreted as hyphenation
     codes.  A `%' character in the patterns file introduces a comment
     that continues to the end of the line.

     If no `hpf' request is specified (either in the document or in a
     macro package), `gtroff' won't hyphenate at all.

     The set of hyphenation patterns is associated with the current
     language set by the `hla' request.  The `hpf' request is usually
     invoked by the `troffrc' or `troffrc-end' file; by default,
     `troffrc' loads hyphenation patterns for American English (in file
     `hyphen.us').

     `hpf' will cause an error if there is no current hyphenation
     language.

 - Request: hcode c1 code1 c2 code2 ...
     Sets the hyphenation code of character C1 to CODE1, that of C2 to
     CODE2, etc.  A hyphenation code must be a single input character
     (not a special character) other than a digit or a space.
     Initially each lower-case letter (`a'-`z') has its hyphenation set
     to itself, and each upper-case letter (`A'-`Z') has a hyphenation
     code which is the lower-case version of itself.

     This request will be ignored if it has no parameter.

 - Request: hym [LENGTH]
     Set the (right) hyphenation margin to LENGTH.  If the current
     adjustment mode is not `b', the line will not be hyphenated if it
     is shorter than LENGTH.  Without argument, the hyphenation margin
     will be reset to its default value, which is 0.  The default
     scaling indicator for this request is `m'.  The hyphenation margin
     is associated with the current environment (see Environments).

     A negative argument will reset the hyphenation margin to zero,
     emitting a warning of type `range'.

     The current hyphenation margin is available in the `.hym' register.

 - Request: hys [HYPHENATION_SPACE]
     Set the hyphenation space to HYPHENATION_SPACE.  If the current
     adjustment mode is `b', don't hyphenate the line if it can be
     justified by adding no more than HYPHENATION_SPACE extra space to
     each word space.  Without argument, the hyphenation space is set
     to its default value, which is 0.  The default scaling indicator
     for this request is `m'.  The hyphenation space is associated with
     the current environment (see Environments).

     A negative argument will reset the hyphenation space to zero,
     emitting a warning of type `range'.

     The current hyphenation space is available in the `.hys' register.

 - Request: shc [CHAR]
     Set the soft hyphen character to CHAR.  If the argument is
     omitted, the soft hyphen character will be set to the default
     character `\(hy' (this is the start-up value of `gtroff' also).
     The soft hyphen character is the character which will be inserted
     when a word is hyphenated at a line break.  If the soft hyphen
     character does not exist in the font of the character immediately
     preceding a potential break point, then the line will not be
     broken at that point.  Neither definitions (specified with the
     `char' request) nor translations (specified with the `tr' request)
     are considered when finding the soft hyphen character.

 - Request: hla language
     Set the current hyphenation language to the string LANGUAGE.
     Hyphenation exceptions specified with the `hw' request and
     hyphenation patterns specified with the `hpf' request are both
     associated with the current hyphenation language.  The `hla'
     request is usually invoked by the `troffrc' or the `troffrc-end'
     files; `troffrc' sets the default language to `us'.

     The current hyphenation language is available as a string in the
     read-only number register `.hla'.

          .ds curr_language \n[.hla]
          \*[curr_language]
              => us

Manipulating Spacing
====================

 - Request: sp [DISTANCE]
     Space downwards DISTANCE.  With no argument it will advance
     1 line.  A negative argument will cause `gtroff' to move up the
     page the specified distance.  If the argument is preceded by a `|'
     `gtroff' will move that distance from the top of the page.  This
     request causes a line break.  The default scaling indicator is `v'.

 - Request: ls [NNN]
     Output NNN-1 blank lines after each line of text.  With no
     argument `gtroff' will use the previous value before the last `ls'
     call.

          .ls 2    \" This causes double-spaced output
          .ls 3    \" This causes triple-spaced output
          .ls      \" Again double spaced

     The line spacing is associated with the current environment (see
     Environments).

     The number register `.L' contains the current line spacing setting.

 - Escape: \x spacing
     Sometimes, extra vertical spacing is only needed occasionally,
     e.g. to allow space for a tall construct (like an equation).  The
     `\x' escape will do this.  The escape is given a numerical
     argument, usually enclosed in quotes (like `\x'3p''); the default
     scaling indicator is `v'.  If this number is positive extra
     vertical space will be inserted below the current line.  A
     negative number will add space above.  If this escape is used
     multiple times on the same line, the maximum of the values is used.

     See Escapes, for details on parameter delimiting characters.

     The `.a' number register contains the most recent (nonnegative)
     extra vertical line space.

 - Request: ns
     Enable "no-space mode".  In this mode, spacing (either via `sp' or
     via blank lines) is disabled.  The `bp' request to advance to the
     next page is also disabled, except if it is accompanied by a page
     number (see Page Control, for more information).  This
     mode will end when actual text is output or the `rs' request is
     encountered.

     This request is useful for macros which want to avoid that
     subsequent macros inadvertently insert some vertical space before
     the text starts (for example, to set up the first paragraph after
     a section header).  It is associated with the current diversion
     level.

 - Request: rs
     Disable no-space mode.  This request is associated with the current
     diversion level.

Tabs and Fields
===============

   A tab character (ASCII char 9, EBCDIC char 5) causes a horizontal
movement to the next tab stop (much like it did on a typewriter).

 - Escape: \t
     This escape is a non-interpreted tab character.  In copy mode
     (see Copy-in Mode), `\t' is the same as a real tab character.

 - Request: ta [N1 N2 ... NN T R1 R2 ... RN]
     Change tab stop positions.  This request takes a series of tab
     specifiers as arguments (optionally divided into two groups with
     the letter `T') which indicate where each tab stop is to be
     (overriding any previous settings).

     Tab stops can be specified absolutely, i.e., as the distance from
     the left margin.  For example, the following will set 6 tab stops
     every one inch.

          .ta 1i 2i 3i 4i 5i 6i

     Tab stops can also be specified relatively (using a leading `+')
     which means that the specified tab stop will be set that distance
     from the previous tab stop.  For example, the following is
     equivalent to the previous example.

          .ta 1i +1i +1i +1i +1i +1i

     `gtroff' supports an extended syntax to specify repeat values after
     the `T' mark (these values are always taken as relative) - this is
     the usual way to specify tabs set at equal intervals.  The
     following is, yet again, the same as the previous examples.  It
     does even more since it defines an infinite number of tab stops
     separated by one inch.

          .ta T 1i

     Now we are ready to interpret the full syntax given at the
     beginning: Set tabs at positions N1, N2, ..., NN and then set tabs
     at NN+R1, NN+R2, ..., NN+RN and then at NN+RN+R1, NN+RN+R2, ...,
     NN+RN+RN, and so on.

     Example: `4c +6c T 3c 5c 2c' is equivalent to `4c 10c 13c 18c 20c
     23c 28c 30c ...'.

     The material in each tab column (i.e., the column between two tab
     stops) may be justified to the right or left or centered in the
     column.  This is specified by appending `R', `L', or `C' to the tab
     specifier.  The default justification is `L'.  Example:

          .ta 1i 2iC 2iR

     Some notes:

        * The default unit of the `ta' request is `m'.

        * A tab stop is converted into a non-breakable horizontal
          movement which can be neither stretched nor squeezed.  For
          example,

               .ds foo a\tb\tc
               .ta T 5i
               \*[foo]

          creates a single line which is a bit longer than 10 inches (a
          string is used to show exactly where the tab characters are).
          Now consider the following:

               .ds bar a\tb b\tc
               .ta T 5i
               \*[bar]

          `gtroff' first converts the tab stops of the line into
          unbreakable horizontal movements, then splits the line after
          the second `b' (assuming a sufficiently short line length).
          Usually, this isn't what the user wants.

        * Superfluous tabs (i.e., tab characters which do not
          correspond to a tab stop) are ignored except the first one
          which delimits the characters belonging to the last tab stop
          for right-justifying resp. centering.  Consider the following
          example

               .ds Z   foo\tbar\tfoo
               .ds ZZ  foo\tbar\tfoobar
               .ds ZZZ foo\tbar\tfoo\tbar
               .ta 2i 4iR
               \*[Z]
               .br
               \*[ZZ]
               .br
               \*[ZZZ]
               .br

          which produces the following output:

               foo                 bar              foo
               foo                 bar           foobar
               foo                 bar              foobar

          The first line right-justifies the second `foo' relative to
          the tab stop.  The second line right-justifies `foobar'.  The
          third line finally right-justifies only `foo' because of the
          additional tab character which marks the end of the string
          belonging to the last defined tab stop.

        * Tab stops are associated with the current environment (see
          Environments).

        * Calling `ta' without an argument will unset all tab stops.

        * The start-up value of `gtroff' is `T 0.5i'.  This value is
          used even in nroff mode (contrary to UNIX `nroff' which has
          tab stops preset every 0.8i).

     The number register `.tabs' contains a string representation of the
     current tab settings suitable for use as an argument to the `ta'
     request.

          .ds tab-string \n[.tabs]
          \*[tab-string]
              => T120u

 - Request: tc [FILL-CHAR]
     Normally `gtroff' will fill the space to the next tab stop with
     space.  This can be changed with the `tc' request.  With no
     argument `gtroff' will revert to using space, which is the default.
     The value of this "tab repitition" character is associated with the
     current environment (see Environments).

Leaders
-------

   Sometimes it may may be desirable to use the `tc' request to fill a
particular tab stop with a given character (for example dots in a table
of contents), but also normal tab stops on the rest of the line.  For
this `gtroff' provides an alternate tab mechanism, called "leaders"
which will do just that.

   A leader character (character code 1) behaves similarly to a tab
character: It moves to the next tab stop.  The only difference is that
for this movement, the fill character defaults to a period character and
not to space.

 - Escape: \a
     This escape is a non-interpreted leader character.  In copy mode
     (see Copy-in Mode), `\a' is the same as a real leader
     character.

 - Request: lc [FILL-CHAR]
     The character that will be repeated can be declared with the `lc'
     request.  Without an argument, leaders will act the same as tabs
     (i.e., using space for filling).  `gtroff''s start-up value is `.'.
     The value of this "leader repitition" character is associated with
     the current environment (see Environments).

   For a table of contents, to name an example, tab stops may be
defined so that the section number is one tab stop, the title is the
second with the remaining space being filled with a line of dots, and
then the page number slightly separated from the dots.

     .ds entry 1.1\tFoo\a\t12
     .lc .
     .ta 1i 5i +.25i
     \*[entry]

This produces

     1.1  Foo..........................................  12

Fields
------

   "Fields" are a more general way of laying out tabular data.  A field
is defined as the data between a pair of "delimiting characters".  It
contains substrings which are separated by "padding characters".  The
width of a field is the distance on the _input_ line from the position
where the field starts to the next tab stop.  A padding character
inserts stretchable space similar to TeX's `\hss' command (thus it can
even be negative) to make the sum of all substring lengths plus the
stretchable space equal to the field width.  If more than one padding
character is inserted, the available space is evenly distributed among
them.

 - Request: fc [DELIM-CHAR [PADDING-CHAR]]
     Define a delimiting and a padding character for fields.  If the
     latter is missing, the padding character defaults to a space
     character.  If there is no argument at all, the field mechanism is
     disabled (which is the default).  Note that contrary to e.g. the
     tab repitition character, delimiting and padding characters are
     not associated to the current environment (see Environments).

     Example:

          .fc # ^
          .ta T 3i
          #foo^bar^smurf#
          .br
          #foo^^bar^smurf#

     and here the result:

          foo         bar          smurf
          foo            bar       smurf

Character Translations
======================

   The control character (`.') and the no-break control character (`'')
can be changed with the `cc' and `c2' requests, respectively.

 - Request: cc [C]
     Set the control character to C.  With no argument the default
     control character `.' is restored.  The value of the control
     character is associated with the current environment (see
     Environments).

 - Request: c2 [C]
     Set the no-break control character to C.  With no argument the
     default control character `'' is restored.  The value of the
     no-break control character is associated with the current
     environment (see Environments).

 - Request: eo
     Disable the escape mechanism completely.  After executing this
     request, the backslash character `\' no longer starts an escape
     sequence.

     This request can be very helpful in writing macros since it is not
     necessary then to double the escape character.  Here an example:

          .\" This is a simplified version of the
          .\" .BR request from the man macro package
          .eo
          .de BR
          .  ds result \&
          .  while (\n[.$] >= 2) \{\
          .    as result \fB\$1\fR\$2
          .    shift 2
          .  \}
          .  if \n[.$] .as result \fB\$1
          \*[result]
          .  ft R
          ..
          .ec

 - Request: ec [C]
     Set the escape character to C.  With no argument the default
     escape character `\' is restored.  It can be also used to re-enable
     the escape mechanism after an `eo' request.

     Note that changing the escape character globally will likely break
     macro packages since `gtroff' has no mechanism (like TeX) to
     `intern' macros, i.e., to convert a macro definition into an
     internal form which is independent of its representation.  If a
     macro is called, it will be executed literally.

 - Escape: \e
     This escape sequence prints the current escape character (which is
     the backslash character `\' by default).

   A "translation" is a mapping of an input character to an output
character.  The default mappings are given in the font definition files
for the specific output device (see Font Files); all mappings (both
with `tr' and in the font definition files) occur at output time, i.e.,
the input character gets assigned the metric information of the mapped
output character.

 - Request: tr ABCD...
     Translate character A to B, character C to D, etc.  If there is an
     odd number of arguments, the last one will be translated to the
     space character.

     Some notes:

        * Special characters (`\(XX', `\[XXX]', `\C'XXX'', `\'', `\`',
          `\-', `\_'), characters defined with the `char' request, and
          numbered characters (`\N'XXX'') can be translated also.

        * The `\e' escape can be translated also.

        * Characters can be mapped onto the `\%' escape (but `\%' can't
          be mapped onto another character).

        * The following characters can't be translated: space (with one
          exception, see below), backspace, newline, leader (and `\a'),
          tab (and `\t').

        * Translations are not considered for finding the soft hyphen
          character set with the `shc' request.

        * The character pair `C\&' (this is an arbitrary character C
          followed by the zero width space character) will map this
          character to nothing.

               .tr a\&
               foo bar
                   => foo br

          It is even possible to map the space character to nothing:

               .tr aa \&
               foo bar
                   => foobar

          As shown in the example, the space character can't be the
          first character pair as an argument of `tr'.  Additionally,
          it is not possible to map the space character to any other
          character; requests like `.tr aa x' will undo `.tr aa \&'
          instead.

          If justification is active, lines will be justified inspite
          of the `empty' space character (but there is no minimal
          distance, i.e. the space character, between words).

        * After an output character has been constructed (this happens
          at the moment immediately before the character is appended to
          an output character list, either by direct output, in a
          macro, diversion, or string), it is no longer affected by
          `tr'.

        * Without an argument, the `tr' request is ignored.

 - Request: trnt ABCD...
     `trnt' is the same as the `tr' request except that the
     translations do not apply to text that is transparently throughput
     into a diversion with `\!'.  See Diversions, for more
     information.

     For example,

          .tr ab
          .di x
          \!.tm a
          .di
          .x

     will print `b'; if `trnt' is used instead of `tr' it will print
     `a'.

Troff and Nroff Mode
====================

   Originally, `nroff' and `troff' were two separate programs, the
former for tty output, the latter for everything else.  With GNU
`troff', both programs are merged into one executable.

   Usually, a macro package can be used with both `nroff' and `troff'.
Nevertheless, it is sometimes necessary to make a distinction between
the two programs (resp. modes), and `gtroff' provides two built-in
conditions `n' and `t' for the `if', `ie', and `while' requests to
decide whether `gtroff' shall behave like `nroff' or like `troff'.

 - Request: troff
     Make the `t' built-in condition true (and the `n' built-in
     condition false) for `if', `ie', and `while' conditional requests.
     This is the default if `gtroff' (_not_ `groff') is started with
     the `-R' switch to avoid loading of the start-up files `troffrc'
     and `troffrc-end'.  Without `-R', `gtroff' stays in troff mode if
     the output device is not a tty (e.g. `ps').

 - Request: nroff
     Make the `n' built-in condition true (and the `t' built-in
     condition false) for `if', `ie', and `while' conditional requests.
     This is the default if `gtroff' uses a tty output device; the
     code for switching to nroff mode is in the file `tmac.tty' which
     will be loaded by the start-up file `troffrc'.

   See Conditionals and Loops, for more details on built-in
conditions.

Line Layout
===========

   The following drawing shows the dimensions which `gtroff' uses for
placing a line of output onto the page.  They are labeled with the
request which manipulates each dimension.

                     -->| in |<--
                        |<-----------ll------------>|
                   +----+----+----------------------+----+
                   |    :    :                      :    |
                   +----+----+----------------------+----+
                -->| po |<--
                   |<--------paper width---------------->|

These dimensions are:

`po'
     "Page offset" - this is the leftmost position of text on the final
     output, defining the "left margin".

`in'
     "Indentation" - this is the distance from the left margin where
     text will be printed.

`ll'
     "Line length" - this is the distance from the left margin to right
     margin.

     .in +.5i
     .ll -.5i
     A bunch of really boring text which should
     be indented from both margins.
     Replace me with a better (and more) example!
     .in -.5i
     .ll +.5i

 - Request: po [OFFSET]
 - Request: po +offset
 - Request: po -offset
     Set horizontal page offset to OFFSET (resp. increment or decrement
     the current value by OFFSET).  Note that this request does not
     cause a break, so changing the page offset in the middle of text
     being filled may not yield the expected result.  The initial value
     is 1i if in troff mode, and 0 if in nroff mode (see Troff and Nroff Mode);
     the default scaling indicator is `m' (and not `v'
     as incorrectly documented in the original UNIX troff manual).

     The current page offset can be found in the built-in number
     register `.o'.

     If `po' is called without an argument, the page offset is reset to
     the previous value before the last call to `po'.

          .po 3i
          \n[.o]
              => 720
          .po -1i
          \n[.o]
              => 480
          .po
          \n[.o]
              => 720

 - Request: in [INDENT]
 - Request: in +indent
 - Request: in -indent
     Set indentation to INDENT (resp. increment or decrement the
     current value by INDENT).  This request causes a break.
     Initially, there is no indentation.

     If `in' is called without an argument, the indentation is reset to
     the previous value before the last call to `in'.  The default
     scaling indicator is `m'.

     The indentation is associated with the current environment.

     If a negative indentation value is specified (which is not
     allowed), `gtroff' emits a warning of type `range' and sets the
     indentation to zero.

     The effect of `in' is delayed until a partially collected line (if
     it exists) is output.

     The current indentation (as set by `in') can be found in the
     built-in number register `.i'.

 - Request: ti offset
 - Request: ti +offset
 - Request: ti -offset
     Temporarily indent the next output line by OFFSET.  If an
     increment or decrement value is specified, adjust the temporary
     indentation relative to the value set by the `in' request.

     This request causes a break; its value is associated with the
     current environment.  The default scaling indicator is `m'.  A
     call of `ti' without an argument is ignored.

     If the total indentation value is negative (which is not allowed),
     `gtroff' emits a warning of type `range' and sets the temporary
     indentation to zero.  `Total indentation' is either OFFSET if
     specified as an absolute value, or the temporary plus normal
     indentation, if OFFSET is given as a relative value.

     The effect of `ti' is delayed until a partially collected line (if
     it exists) is output.

     The number register `.in' is the indentation that applies to the
     current output line.

     The difference between `.i' and `.in' is that the latter takes
     into account whether a partially collected line still uses the old
     indentation value resp. a temporary indentation value is active.

 - Request: ll [LENGTH]
 - Request: ll +length
 - Request: ll -length
     Set the line length to LENGTH (resp. increment or decrement the
     current value by LENGTH).  Initially, the line length is set to
     6.5i.  The effect of `ll' is delayed until a partially collected
     line (if it exists) is output.  The default scaling indicator
     is `m'.

     If `ll' is called without an argument, the line length is reset to
     the previous value before the last call to `ll'.  If a negative
     line length is specified (which is not allowed), `gtroff' emits a
     warning of type `range' and sets the line length to zero.

     The line length is associated with the current environment.

     The current line length (as set by `ll') can be found in the
     built-in number register `.l'.  The number register `.ll' is the
     line length that applies to the current output line.

     Similar to `.i' and `.in', the difference between `.l' and `.ll'
     is that the latter takes into account whether a partially
     collected line still uses the old line length value.

Page Layout
===========

   `gtroff' provides some very primitive operations for controlling
page layout.

 - Request: pl [LENGTH]
 - Request: pl +length
 - Request: pl -length
     Set the "page length" to LENGTH (resp. increment or decrement the
     current value by LENGTH).  This is the length of the physical
     output page.  The default scaling indicator is `v'.

     The current setting can be found in the built-in number register
     `.p'.

     Note that this only specifies the size of the page, not the top and
     bottom margins.  Those are not set by groff directly.  See
     Traps, for further information on how to do this.

     Negative `pl' values are possible also, but not very useful: No
     trap is sprung, and each line is output on a single page (thus
     suppressing all vertical spacing).

   `gtroff' provides several operations which help in setting up top
and bottom titles (or headers and footers).

   The `tl' request will print a "title line", which consists of three
parts: a left justified portion, a centered portion and a right
justified portion.  The argument to `tl' is specified as
`'LEFT'CENTER'RIGHT''.  The `%' character is replaced with the current
page number.  This character can be changed with the `pc' request (see
below).

   The title line is printed using its own line length, which is
specified with the `lt' request.  The current setting of this is
available in the `.lt' number register.

   The `pn' request will change the page number of the _next_ page.
The only argument is the page number.

   The current page number is stored in the number register `%'.  The
number register `.pn' contains the number of the next page: either the
value set by a `pn' request, or the number of the current page plus 1.

   The `pc' request will change the page number character (used by the
`tl' request) to a different character.  With no argument, this
mechanism is disabled.

   See Traps.

Page Control
============

   To stop processing the current page, and move to the next page,
invoke the `bp' request.  This request will also cause a break.  It can
also take an argument of what the next page should be numbered.  The
only difference between `bp' and `pn' is that `pn' does not cause a
break or actually eject a page.

     .de newpage
     'bp
     'sp .5i
     .tl 'left top'center top'right top'
     'sp .3i
     ..

   It is often necessary to force a certain amount of space before a new
page occurs.  This is most useful to make sure that there is not a
single "orphan" line left at the bottom of a page.  The `ne' request
will ensure that there is a certain distance, specified by the first
argument, before the next page is triggered (see Traps, for
further information).  The default unit for `ne' is `v' and the default
argument is 1v.

   For example, to make sure that no fewer than 2 lines get orphaned,
do the following before each paragraph:

     .ne 2
     .ti +5n
     text

   `sv' is similar to the `ne' request; it reserves the specified
amount of vertical space.  If the desired amount of space exists before
the next trap (bottom page boundary), the space will be output
immediately.  If there is not enough space, it is stored for later
output via the `os' request.  The default argument is 1v and the
default unit is `v'.

Fonts
=====

   `gtroff' has the ability to switch fonts at any point in the text.
There are two ways to do this, via the `ft' request and the `\f' escape.

   Fonts are generally specified as upper-case strings, which are
usually 1 to 4 characters representing an abbreviation or acronym of
the font name.

   The basic set of fonts are `R', `I', `B', and `BI'.  These are Times
Roman, Italic, Bold, and Bold Italic.  There is also at least one
symbol font which contains various special symbols (Greek,
mathematics).  Such symbols fonts cannot be used directly, but should be
used via an escape.

Changing Fonts
--------------

   Font changes can be done either with the `ft' request or the `\f'
request.  With no arguments, it will switch to the previous font (also
known as `P').

     eggs, bacon,
     .ft B
     spam
     .ft
     and sausage.

   The `\f' escape is useful for changing fonts in the middle of words:

     eggs, bacon, \fBspam\fP and sausage.

Both of the above examples will produce the same output.  Note the usage
of `P' to indicate the previous font - using `\f' it is not possible to
omit this parameter.

   Sometimes, when putting letters of different fonts, more or less
space at such boundaries are needed.  There are two escapes to help
with this.

   The `\/' escape increases the width of the preceding character so
that the spacing between that character and the following character will
be correct if the following character is a Roman character.  For
example, if an italic f is immediately followed by a Roman right
parenthesis, then in many fonts the top right portion of the f will
overlap the top left of the right parenthesis.  It is a good idea to use
this escape sequence whenever an italic character is immediately
followed by a Roman character without any intervening space.  This small
amount of space is also called "italic correction".

   The `\,' escape modifies the spacing of the following character so
that the spacing between that character and the preceding character will
be correct if the preceding character is a Roman character.  It is a
good idea to use this escape sequence whenever a Roman character is
immediately followed by an italic character without any intervening
space.  In analogy to above, this space could be called "left italic
correction", but this term isn't used widely.

   The `ftr' request will translate fonts; its syntax is

     .ftr F G

which translates font F to font G.  Whenever a font named F is referred
to in a `\f' escape sequence, or in the `ft', `ul', `bd', `cs', `tkf',
`special', `fspecial', `fp', or `code' requests, font G will be used.
If G is missing, or equal to F then font F will not be translated.

Font Families
-------------

   Due to the variety of fonts available, `gtroff' has added the
concept of font families.  Each of these families has four styles (`R',
`I', `B' and `BI').

   The fonts are specified as the concatenation of the font family and
style.  Specifying a font without the family part will cause `gtroff'
to use that style of the current family.  By default, `gtroff' uses the
Times family.

   This way, it is possible to use the basic four fonts and to select a
different font family on the command line.

   Font families can be switched with the `fam' request.  The current
font family is available in the number register `.fam'.  This is a
string-valued register.

     spam,
     .fam H
     spam,
     .ft B
     spam,
     .fam T
     spam,
     .ft AR
     baked beans,
     .ft R
     and spam.

Font Positions
--------------

   For the sake of old phototypesetters and compatability with old
versions of `troff', `gtroff' has the concept of font "positions", on
which various fonts are mounted.  The last one or two are reserved for
the symbol font(s).

   New fonts can be mounted with the `fp' request.  These numeric
positions can then be referred to with font changing commands.  When
`gtroff' starts it is using font number one.

     .fp 1 H
     .fp 2 HI
     .fp 3 HB
     wink, wink,
     .ft 2
     nudge, nudge,
     .ft
     .ft 3
     say no more!
     .ft

Note that after these font changes have taken place, the original font
is restored.

   The current font in use, as a font position, is available in number
register `.f'.  This can be useful to remember the current font, for
later recall.

     .nr save-font \n(.f
     ... lots 'o text ...
     .ft \n[save-font]

   The number of the next free font position is available in the number
register `.fp'.  This is useful when mounting a new font, like so:

     .fp \n[.fp] NEATOFONT

   Fonts not listed in the `DESC' file are automatically mounted on the
next available font position when they are referenced.  If a font is to
be mounted explicitly with the `fp' request on an unused font position,
it should be mounted on the first unused font position, which can be
found in the `.fp' register.  Although `gtroff' does not enforce this
strictly, it will not allow a font to be mounted at a position whose
number is much greater than that of any currently used position.

   The `fp' request has an optional third argument.  This argument
gives the external name of the font, which is used for finding the font
description file.  The second argument gives the internal name of the
font which is used to refer to the font in `gtroff' after it has been
mounted.  If there is no third argument then the internal name will be
used as the external name.  This feature make it possible to use fonts
with long names in compatibility mode.

Using Symbols
-------------

   Symbols can be inserted by using a special escape sequence.  This
escape is simply the escape character (usually a backslash) followed by
an identifier.  The symbol identifiers have to be two or more
characters, since single characters conflict with all the other
escapes.  The identifier can be either preceded by a parenthesis if it
is two characters long, or surrounded by square brackets.  So, the
symbol for the mathematical Greek letter `pi' can be produced either by
`\(*p' or `\[*p]'.

     area = \(*p\fIr\fP\u2\d

   The escape `\C'XXX'' will typeset the character named XXX.  Normally
it is more convenient to use `\[XXX]'.  But `\C' has the advantage that
it is compatible with recent versions of `ditroff' and is available in
compatibility mode.

   The escape `\N'N'' will typeset the character with code N in the
current font.  N can be any integer.  Most devices only have characters
with codes between 0 and 255.  If the current font does not contain a
character with that code, special fonts will _not_ be searched.  The
`\N' escape sequence can be conveniently used on conjunction with the
`char' request:

     .char \[phone] \f(ZD\N'37'

The code of each character is given in the fourth column in the font
description file after the charset command.  It is possible to include
unnamed characters in the font description file by using a name of
`---'; the `\N' escape sequence is the only way to use these.

   Each character has certain properties associated with it.  These
properties can be modified with the `cflags' request.  The first
argument is the the sum of the desired flags and the remaining arguments
are the characters to have those properties.

`1'
     the character ends sentences (initially characters `.?!' have this
     property)

`2'
     lines can be broken before the character (initially no characters
     have this property)

`4'
     lines can be broken after the character (initially the characters
     `-\(hy\(em' have this property)

`8'
     the character overlaps horizontally (initially the characters
     `\(ul\(rn\(ru' have this property)

`16'
     the character overlaps vertically (initially character `\(br' has
     this property)

`32'
     an end of sentence character followed by any number of characters
     with this property will be treated as the end of a sentence if
     followed by a newline or two spaces; in other words the character
     is "transparent" for the purposes of end of sentence recognition -
     this is the same as having a zero space factor in TeX (initially
     characters `"')]*\(dg\(rq' have this property).

   New characters can be created with the `char' request.  It is called
as

     .char C STRING

This defines character C to be STRING.  Every time character C needs to
be printed, STRING will be processed in a temporary environment and the
result will be wrapped up into a single object.  Compatibility mode
will be turned off and the escape character will be set to `\' while
STRING is being processed.  Any emboldening, constant spacing or track
kerning will be applied to this object rather than to individual
characters in STRING.  A character defined by this request can be used
just like a normal character provided by the output device.  In
particular other characters can be translated to it with the `tr'
request; it can be made the leader character by the `lc' request;
repeated patterns can be drawn with the character using the `\l' and
`\L' escape sequences; words containing the character can be hyphenated
correctly, if the `hcode' request is used to give the character a
hyphenation code.  There is a special anti-recursion feature: use of
character within the character's definition will be handled like normal
characters not defined with `char'.

   A character definition can be removed with the `rchar' request.  Its
arguments are the characters to be removed.  This undoes the effect of
a `char' request.

   See Special Characters.

Artificial Fonts
----------------

   There are a number of requests for artificially creating fonts.
These are largely vestigial remains from the days when output devices
did not have a wide variety of fonts, and when `nroff' and `troff' were
separate programs.  These are no longer necessary in GNU `troff'.

   The `ul' request will print subsequent lines in italics on a device
capable of it, or underline the text on a character output device.  The
single argument is the number of lines to be "underlined," with no
argument, the next line will be underlined.

   The `cu' request is similar to `ul' ...

   The `uf' request will set the underline font used by `ul' and `cu'.

   The `bd' request artificially creates a bold font by printing each
character twice, slightly offset.  The first argument specifies the font
to embolden, and the second is the number of basic units, minus one, by
which the two characters will be offset.  If the second argument is
missing, emboldening will be turned off.

Ligatures and Kerning
---------------------

   The ligature mechanism can be switched on or off with the `lg'
request; if the parameter is non-zero or missing, ligatures are enabled,
otherwise disabled.  Default is on.  The current ligature mode can be
found in the number register `.lg' (set to 1 if ligatures are enabled,
0 otherwise).

   If the font description file contains pairwise kerning information,
characters from that font will be kerned.  Kerning between two
characters can be inhibited by placing `\&' between them.

   Kerning can be activated with the `kern' request.  If the parameter
is non-zero or missing, enable pairwise kerning, otherwise disable it.
The number register `.kern' is set to 1 if pairwise kerning is enabled,
0 otherwise.

   Track kerning must be used with great care since it is usually
considered bad typography if the reader notices the effect.  The syntax
of the `tkf' request is like this:

     .tkf F S1 N1 S2 N2

Enable track kerning for font F.  If the current font is F the width of
every character will be increased by an amount between N1 and N2; if
the current point size is less than or equal to S1 the width will be
increased by N1; if it is greater than or equal to S2 the width will be
increased by N2; if the point size is greater than or equal to S1 and
less than or equal to S2 the increase in width is a linear function of
the point size.

Sizes
=====

   `gtroff' uses two dimensions with each line of text, type size and
vertical spacing.  The "type size" is the height from the text
"baseline" to the top of the tallest character (descenders may drop
below this baseline).  "Vertical spacing" is the amount of space
`gtroff' allows for a line of text; normally, this is about 20% larger
than the current type size.  Ratios smaller than this can result in
hard-to-read text; larger that this, it will spread the text out more
vertically (useful for term papers).  By default, `gtroff' uses
10 point type on 12 point spacing.

   The difference between type size and vertical spacing is known, by
typesetters, as "leading".

Changing Type Sizes
-------------------

   Using the `ps' request and the `\s' escape the type size can be
changed.  The `vs' request will change the vertical spacing.  The
default unit for the `ps' and `vs' requests are points.  The number
registers `.s' and `.v' contain the current type size and vertical
spacing.

   These requests take parameters in units of points.  It is possible to
specify sizes as an absolute size, or as a relative change from the
current size.  The size 0 means go back to the previous size.  With no
argument it will also revert to the previous size.

     snap, snap,
     .ps +2
     grin, grin,
     .ps +2
     wink, wink, \s+2nudge, nudge,\s+8 say no more!
     .ps 10

   The `\s' escape may be called in a variety of ways.  Much like other
escapes there must be a way to determine where the argument ends and
the text begins.  Any of the following forms are valid:

`\sN'
     Set the point size to N points.  N must be either 0 or in the
     range 4 to 39.

`\s+N'
`\s-N'
     Increase resp. decrease the point size by N points.  N must be
     exactly one digit.

`\s(NN'
     Set the point size to NN points.  NN must be exactly two digits.

`\s+(NN'
`\s-(NN'
`\s(+NN'
`\s(-NN'
     Increase resp. decrease the point size by NN points.  NN must be
     exactly two digits.

   See Fractional Type Sizes, for yet another syntactical form of
using the `\s' escape.

   Some devices may only have certain permissible sizes, in which case
`gtroff' will round to the nearest permissible size.

Fractional Type Sizes
---------------------

   A "scaled point" is equal to 1/SIZESCALE points, where SIZESCALE is
specified in the `DESC' file (1 by default.)  There is a new scale
indicator `z' which has the effect of multiplying by SIZESCALE.
Requests and escape sequences in `gtroff' interpret arguments that
represent a point size as being in units of scaled points, but they
evaluate each such argument using a default scale indicator of `z'.
Arguments treated in this way are the argument to the `ps' request, the
third argument to the `cs' request, the second and fourth arguments to
the `tkf' request, the argument to the `\H' escape sequence, and those
variants of the `\s' escape sequence that take a numeric expression as
their argument (see below).

   For example, suppose SIZESCALE is 1000; then a scaled point will be
equivalent to a millipoint; the request `.ps 10.25' is equivalent to
`.ps 10.25z' and thus sets the point size to 10250 scaled points, which
is equal to 10.25 points.

   It would make no sense to use the `z' scale indicator in a numeric
expression whose default scale indicator was neither `u' nor `z', and
so `gtroff' disallows this.  Similarly it would make no sense to use a
scaling indicator other than `z' or `u' in a numeric expression whose
default scale indicator was `z', and so `gtroff' disallows this as well.

   There is also new scale indicator `s' which multiplies by the number
of units in a scaled point.  So, for example, `\n[.ps]s' is equal to
`1m'.  Be sure not to confuse the `s' and `z' scale indicators.

   The number register `.s' returns the point size in points as decimal
fraction.  There is also a new number register `.ps' that returns the
point size in scaled points.

   The last-requested point size in scaled points is contained in the
`.psr' number register.  The last requested point size in points as a
decimal fraction can be found in `.sr'.  This is a string-valued
register.

`\s[N]'
`\s'N''
     Set the point size to N scaled points; N is a numeric expression
     with a default scale indicator of `z'.

`\s[+N]'
`\s[-N]'
`\s+[N]'
`\s-[N]'
`\s'+N''
`\s'-N''
`\s+'N''
`\s-'N''
     Increase or resp. decrease the point size by N scaled points; N is
     a numeric expression with a default scale indicator of `z'.

   See Font Files.

Strings
=======

   `gtroff' has string variables, which are entirely for user
convenience (i.e. there are no built-in strings).  They are defined via
the `ds' request.

     .ds UX \s-1UNIX\s0\u\s-3tm\s0\d

   They are interpolated, or expanded in-place, via the `\*' escape:

     The \*(UX Operating System

   If the string named by the `\*' does not exist, the escape will be
replaced by nothing.

   *Caution:* Unlike other requests, the second argument to the `ds'
request takes up the entire line including trailing spaces.  This means
that comments on a line with such a request can introduce unwanted
space into a string.

     .ds UX \s-1UNIX\s0\u\s-3tm\s0\d \" UNIX trademark

Instead the comment should be put on another line or have the comment
escape adjacent with the end of the string.

     .ds UX \s-1UNIX\s0\u\s-3tm\s0\d\"  UNIX trademark

   To produce leading space the string can be started with a double
quote.  No trailing quote is needed; in fact, any trailing quote is
included in your string.

     .ds sign "           Yours in a white wine sauce,

   The `as' request will append a string to another string.  It works
similar to the `ds' request except that it appends the second argument
onto the string named by the first argument.

     .as sign " with shallots, onions and garlic,

   Strings are not limited to a single line of text.  A string can span
several lines by escaping the newlines with a backslash.  The resulting
string will be stored _without_ the newlines.

     .ds foo lots and lots \
     of text are on these \
     next several lines

   Rudimentary string manipulation routines are given with the
`substring' and `length' requests.  The former has the following syntax:

     .substring XX N1 [N2]

It replaces the string in register XX with the substring defined by the
indices N1 and N2.  The first character in the string has index one.
If N2 is omitted, it is taken to be equal to the string's length.  If
the index value N1 or N2 is negative or zero, it will be counted from
the end of the string, going backwards: The last character has index 0,
the character before the last character has index -1, etc.

   Here the syntax of the `length' request:

     .length XX STRING

It computes the length of STRING and returns it in the number
register XX (which is not necessarily defined before).

   See Identifiers, and Comments.

Conditionals and Loops
======================

   In `if' and `while' requests, there are several more operators
available:

`e'
`o'
     True if the current page is even or odd numbered (respectively).

`n'
     True if the document is being processed in nroff mode.

`t'
     True if the document is being processed in troff mode.

`'XXX'YYY''
     True if the string XXX is equal to the string YYY.  Other
     characters can be used in place of the single quotes.  The strings
     are "formatted" before being compared.

`rXXX'
     True if there is a number register named XXX.

`dXXX'
     True if there is a string, macro, diversion, or request named XXX.

`cCH'
     True if there is a character CH available; CH is either an ASCII
     character or a special character (`\(CH' or `\[CH]'); the
     condition will also be true if CH has been defined by the `char'
     request.

if-else
-------

   `gtroff' has if-then-else constructs like other languages, although
the formatting can be painful.

   The `if' request has the following syntax:

     .if EXPR ANYTHING

where EXPR is the expression to be evaluated; ANYTHING (the remainder
of the line) will be executed if EXPR evaluates to non-zero (true).
ANYTHING will be interpreted as though it was on a line by itself.
See Expressions, for more info.

   Here are some examples:

     .if t .ls 2				\" double spacing in troff
     .if 0 .ab how'd this happen?

   An if-then-else is written using two requests `ie' and `el'.  The
first request is the `if' part and the latter is the `else' part.

     .ie
     .el

   In many cases more than one request is to be executed as a result of
any of these requests.  This can be done using the `\{' and `\}'
escapes.  The following example shows the possible ways to use these
escapes (note the position of the opening and closing braces).

     .ie t \{\
     .    ds lq ``
     .    ds rq ''
     .\}
     .el \
     .\{\
     .    ds lq "
     .    ds rq "\}
     .ds qq "

   See Expressions.

while
-----

   `gtroff' provides a looping construct using the `while' request,
which is used much like the `if' (and related) requests.  The first
argument is an expression which will be evaluated.  The `while' request
will interpret the remainder of the line until the expression evaluates
to 0 or false.

     .nr a 0 1
     .while (\na<9) \&\n+a,
     \&\n+a

The preceding example produces:

     1, 2, 3, 4, 5, 6, 7, 8, 9, 10

Note the usage of the `\&' escape to avoid a control character at the
beginning of a line.

   The `break' request will "break" out of a while loop.  Be sure not
to confuse this with the `br' request (causing a line break).  The
`continue' request will finish the current iteration of a while loop,
immediately restarting the next iteration.

   See Expressions.

Writing Macros
==============

   A "macro" is a collection of text and embedded commands which can be
invoked multiple times.  Macros are used for defining common operations.
Macros are defined using the `de' request.  This request takes a name
for the macro as the first argument.  Subsequent lines are copied into
an internal buffer until the line `..' is encountered.  The optional
second argument to `de' can change this ending token.

   Here a small example macro called `P' which will cause a break and
the insertion of some vertical space.  It could be used to separate
paragraphs.

     .de P
     .br
     .sp .8v
     ..

   The `am' request works similarly to `de' except it appends onto the
macro named by the first argument.  So, to make the previously defined
`P' macro actually do indented instead of block paragraphs, is is
possible to add the necessary code to the existing macro like this:

     .am P
     .ti +5n
     ..

   Macros can be aliased with the `als' request.

Copy-in Mode
------------

   When `gtroff' reads in the text for a macro or diversion it copies
the text (including request lines, but excluding escapes) into an
internal buffer.  Escapes will be converted into an internal form,
except for `\n', `\$', `\*', `\\' and `\<RET>' which are evaluated and
inserted into the text where the escape was located.  This is known as
"copy-in" mode or "copy" mode.

   What this means is that you can specify when these escapes are to be
evaluated (either at copy-in time or at the time of use) by insulating
the escapes with an extra backslash.  Compare this to the `\def' and
`\edef' commands in TeX.

   For example, the following will result in the numbers 20 andbeing
printed:

     .nr x 20
     .de y
     .nr x 10
     \&\nx
     \&\\nx
     ..
     .y

Parameters
----------

   The arguments to a macro can be examined using a variety of escapes.
The number of arguments is available in the `.$' number register.  Any
individual argument can be retrieved with one of the following escapes:

   The escapes `\$N', `\$(NN' and `\$[NNN]' will result in the Nth,
NNth or NNNth argument.  As usual, the first form only accepts a single
number (larger than zero), the second only a two-digit number (larger or
equal to 10), and the third any positive integer value (larger than
zero).  Macros can have an unlimited number of arguments.  Note that due
to copy-in mode, two backslashes should be used on these in actual use
to prevent interpolation until the macro is actually invoked.

   The request `shift' will shift the arguments 1 position, or as many
positions as specified by its argument.  After executing this request,
argument I will become argument I-N; arguments 1 to N will no longer be
available.  Shifting by negative amounts is currently undefined.

   In some cases it is convenient to use all of the arguments at once
(for example, to pass the arguments along to another macro).  The `\$*'
escape is the concatenation of all the arguments separated by spaces.  A
similar escape is `\$@', which is the concatenation of all the
arguments with each surrounded by double quotes, and separated by
spaces.

   The `\$0' escape is the name by which the current macro was invoked.
The `als' request can make a macro have more than one name.

     .de vl
     .ie \\n(.$=1 .ds Vl Pre-Release Version
     .el          .ds Vl Version \\$3, \\$4.
     ..

   This would be called as

     .vl $Id: groff.texinfo,v 1.40 2000/06/18 10:13:51 wlemb Exp $

   See Request Arguments.

Page Motions
============

   Motions up and down the page can be done with the `sp' request.
However, this causes a break so that the actual effect is to move to the
left margin and then to the specified location.

   The request `mk' can be used to mark a location on a page, for
movement to later.  This request takes a register name as an argument in
which to store the current page location.  With no argument it will
store the location in an internal register.  The results of this can be
used later by the `rt' or the `sp' request.  The `rt' request will
return _upwards_ to the location given in the register name given as an
argument, with no argument it will return to the location marked with
the `mk' request

   The following escapes give fine control of movements about the page.

   The `\v'E'' enables arbitrary vertical motion from the current
location on the page.  The argument E specifies the distance to move;
positive is downwards and negative upwards.  The default unit for this
escape is vertical spaces, `v''s.  Beware, however, that `gtroff' will
leave text processing to continue wherever the motion ends, so to avoid
interference with text processing, motions should be balanced.

   There are some special case escapes for vertical motion.

`\r'
     move upwards 1v.

`\u'
     move upwards .5v.

`\d'
     move down .5v.

   Horizontal motions can be done via the `\h'E'' escape.  The
expression E indicates how far to move: positive is rightwards and
negative leftwards.

   There are a number of special case escapes for horizontal motion:

`\<SP>'
     an unbreakable and unpaddable (i.e. not expanded during filling)
     space.  (Note: This is a backslash followed by a space.)

`\~'
     an unbreakable space that stretches like a normal inter-word space
     when a line is adjusted.

`\|'
     a 1/6th em space.

`\^'
     a 1/12th em space.

`\0'
     a space the size of a digit.

`\&'
     A zero width space.

`\)'
     Like `\&' except that it behaves like a character declared with the
     `cflags' request to be transparent for the purposes of end of
     sentence recognition.

   A frequent need is to do horizontal movement based on the width of
some arbitrary text (e.g. given as an argument to a macro).  For that,
there is the escape `\w'TEXT'' which will interpolate to the width of
the given TEXT in basic units.

   Font changes may occur in TEXT which don't affect current settings.

   After use, `\w' sets several registers:

`st'
`sb'
     The highest and lowest point, respectively, in TEXT.

`rst'
`rsb'
     Like the `st' and `sb' registers, but takes account of the heights
     and depths of characters.

`ct'
     is set according to what kinds of characters occur in TEXT:

    0
          only short characters, no descenders or tall characters.

    1
          descender.

    2
          tall character.

    3
          both a descender and a tall character.

`ssc'
     The amount of horizontal space (possibly negative) that should be
     added to the last character before a subscript.

`skw'
     How far to right of the center of the last character in the `\w'
     argument, the center of an accent from a Roman font should be
     placed over that character.

   `\k'

   `.k'

Drawing Requests
================

   `gtroff' provides a number of ways to draw lines and other figures
on the page.  Used in combination with the page motion commands (see
Page Motions, for more info), a wide variety of figures can be
drawn.  However, for complex drawings these operations can be quite
cumbersome, and it may be wise to use graphic preprocessors like `gpic'
or `ggrn'.  See gpic, and ggrn, for more information.

   All drawing is done via escapes.

   The `\l' escape will draw a line rightwards from the current
location.  The full syntax for this escape is like this:

     \l'LC'

where L is the length of the line to be drawn, starting at the current
location; positive numbers will draw to the right, and negative will
draw towards the left.  This can also be specified absolutely (i.e.
with a leading `|') which will draw back to the beginning of the line.

   The optional second parameter C is a character to draw the line
with.  If this second argument is not specified, `gtroff' will use the
underscore character.

   To separate the two arguments (to prevent `gtroff' from interpreting
a drawing character as a scaling indicator) use `\&'.

   Here a small useful example:

     .de box
     \(br\\$*\(br\l'|0\(rn'\l'|0\(ul'
     ..

Note that this works by outputting a box rule (a vertical line), then
the text given as an argument and then another box rule.  Then the line
drawing escapes both draw from the current location to the beginning of
the _input_ line.

   Vertical lines are drawn using the `\L' escape.  Its parameters are
specified similar to the `\l' escape.  If the length is positive, the
movement will be downwards, and upwards for negative values.  The
default character is the box rule character.  As with the vertical
motion escapes, text processing will blindly continue where the line
ends.

   More flexible drawing functions are available via the `\D' escape.
While the previous escapes will work on a character device, these
escapes will not.

`\D'l DX DY''
     Draw a line from the current location to the relative point
     specified by (DX,DY).

`\D'c D''
     Draw a circle with a diameter of D with the leftmost point at the
     current position.

`\D'C D''
     Draw a solid circle with the same parameters as an outlined circle.

`\D'e DX DY''
     Draw an ellipse with a horizontal diameter of DX and a vertical
     diameter of DY with the leftmost point at the current position.

`\D'E DX DY''
     Draw a solid ellipse with the same parameters as an outlined
     ellipse.

`\D'a DX1 DY1 DX2 DY2''
     Draw an arc clockwise from the current location through the two
     specified locations (DX1,DY1) and (DX2,DY2).

`\D'~ DX1 DY1 DX2 DY2 ...''
     Draw a spline from the current location to (DX1,DY1) and then to
     (DX2,DY2), and so on.

`\D'f N''
     Set the shade of gray to be used for filling solid objects to N;
     N must be an integer between 0 and 1000, where 0 corresponds solid
     white and 1000 to solid black, and values in between correspond to
     intermediate shades of gray.  This applies only to solid circles,
     solid ellipses and solid polygons.  By default, a level of 1000
     will be used.

`\D'p DX1 DY1 DX2 DY2 ...''
     Draw a polygon from the current location to (DX1,DY1) and then to
     (DX2,DY2) and so on.  When the specified data points are
     exhausted, a line is drawn back to the starting point.

`\D'P DX1 DY1 DX2 DY2 ...''
     Draw a solid polygon with the same parameters as an outlined
     polygon.

`\D't N''
     Set the current line thickness to N machine units.  A value of
     zero selects the smallest available line thickness.  A negative
     value makes the line thickness proportional to the current point
     size (this is the default behaviour of `ditroff').

   The `\b' escape will "pile" a sequence of characters vertically, and
center it vertically on the current line.  This can be used to build
large brackets and braces.

     \b'\(lt\(bv\(lk\(bv\(lb'

   See Drawing Functions.

Traps
=====

   "Traps" are locations, which, when reached, will call a specified
macro.  These traps can occur at a given location on the page, at a
given location in the current diversion, after a certain number of input
lines or at the end of input.

Page Location Traps
-------------------

   Page location traps are frequently used for page headers and footers.
The following is a simple example of this.

     .de hd                \" Page header
     'sp .5i
     .tl 'Title''date'
     'sp .3i
     ..
     .de fo                \" Page footer
     'sp 1v
     .tl ''%''
     'bp
     ..
     .wh 0   hd            \" trap at top of the page
     .wh -1i fo            \" trap one inch from bottom

   The number register `.t' is the distance to the next trap.

   The location of a trap can be changed later on with the `ch'
request.  The first argument is the name of the macro to be invoked at
the trap, and the second argument is the new location for the trap.
This is useful for building up footnotes in a diversion to allow more
space at the bottom of the page for them.

   The `vpt' request will enable vertical position traps if the
argument is non-zero, disable them otherwise.  Vertical position traps
are traps set by the `wh' or `dt' requests.  Traps set by the `it'
request are not vertical position traps.  The parameter that controls
whether vertical position traps are enabled is global.  Initially
vertical position traps are enabled.  The current setting of this is
available in the number register `.vpt'.

   The number register `.trunc' contains the amount of vertical space
truncated by the most recently sprung vertical position trap, or, if the
trap was sprung by a `ne' request, minus the amount of vertical motion
produced by the `ne' request.  In other words, at the point a trap is
sprung, it represents the difference of what the vertical position
would have been but for the trap, and what the vertical position
actually is.

   The number register `.ne' contains the amount of space that was
needed in the last `ne' request that caused a trap to be sprung.
Useful in conjunction with the `.trunc' register.  See Page Control,
for more information.

Diversion Traps
---------------

   Traps can also be set _within_ a diversion using the `dt' request.
Like `wh' the first argument is the location of the trap and the second
argument is the name of the macro to be invoked.  The number register
`.t' will still work within diversions.  See Diversions, for more
information.

Input Line Traps
----------------

   The `it' request will set an input line trap.  The format for
calling this is

     .it N NAME

where N is the number of lines of input which may be read before
"springing" the trap, NAME is the macro to be invoked.  Request lines
are not counted as input lines.

   For example, one possible use is to have a macro which will print the
next N lines in a bold font.

     .de B
     .it B-end \\$1
     .ft B
     ..
     .de B-end
     .ft R
     ..

End-of-input Traps
------------------

   The `em' request will set a trap at the end of input.  The macro
specified as an argument will be executed after the last line of the
input file has been processed.

   For example, if the document had to have a section at the bottom of
the last page for someone to approve it, the `em' request could be used.

     .de approval
     .ne 5v
     .sp |(\\n(.t-6v)
     .in +4i
     .lc _
     .br
     Approved:\t\a
     .sp
     Date:\t\t\a
     ..
     .em approval

Diversions
==========

   In `gtroff' it is possible to "divert" text into a named storage
area.  Due to the similarity to defining macros it is sometimes said to
be stored in a macro.  This is used for saving text for output at a
later time, which is useful for keeping blocks of text on the same
page, footnotes, tables of contents and indices.

   A diversion is initiated by the `di' request.  Like the `de'
request, it takes an argument of a macro name to divert subsequent text
into.  The `da' macro will append to an existing diversion.

   `di' (resp. `da') without an argument ends the diversion.

   Diversions may be nested.  The number register `.z' contains the
name of the current diversion.  The number register `.d' contains the
current vertical place in the diversion.  If not in a diversion it is
the same as the register `nl'.

   `.h'

   After completing a diversion, the built-in number registers `dn' and
`dl' contain the vertical and horizontal size of the diversion.

     .\" Center text both horizontally & vertically
     .de (c
     .br
     .nf
     .di @c
     ..
     .de )c
     .br
     .di
     .nr @s (((\\n(.tu-\\n(dnu)/2u)-1v)
     .sp \\n(@su
     .ce 1000
     .nf
     ..br
     .ce 0
     .sp \\n(@su
     .br
     .fi
     .rr @s
     ..

   Requests, macros and escapes are interpreted when read into a
diversion.  There are two ways to prevent this; either way will take
the given text and "transparently" embed it into the diversion.  The
first method is to prefix the line with `\!'.  This will cause the
entire line to be transparently inserted into the diversion.  This is
useful for macros which shouldn't be invoked until the diverted text is
actually output.

   The other way is to surround the text by the `\?' escape, i.e.

     \?ANYTHING\?

ANYTHING may not contain newlines; use `\!'  to embed newlines in a
diversion.  The escape sequence `\?' is also recognized in copy mode
and turned into a single internal code; it is this code that terminates
anything.  Thus the following example will print 4.

     .nr x 1
     .nf
     .di d
     \?\\?\\\\?\\\\\\\\nx\\\\?\\?\?
     .di
     .nr x 2
     .di e
     .d
     .di
     .nr x 3
     .di f
     .e
     .di
     .nr x 4
     .f

   The `asciify' request only exists in order to make certain gross
hacks work with GNU `troff'.  It "unformats" the diversion specified as
an argument in such a way that ASCII characters that were formatted and
diverted will be treated like ordinary input characters when the
diversion is reread.  For example, the following will set register `n'
to 1.

     .tr @.
     .di x
     @nr\ n\ 1
     .br
     .di
     .tr @@
     .asciify x
     .x

   See Copy-in Mode.

Environments
============

   It happens frequently that some text should be printed in a certain
format regardless of what may be in effect at the time, for example, in
a trap invoked macro to print headers and footers.  To solve this
`gtroff' has "environments" in which text is processed.  An environment
contains most of the parameters that control text processing.  It is
possible to switch amongst these environments; by default `gtroff'
processes text in environment 0.  The following is the information kept
in an environment.

   * font parameters (size, family, style, character height and slant,
     space and sentence space size)

   * page parameters (line length, title length, vertical spacing, line
     spacing, indentation, line numbering, hyphenation data)

   * fill and adjust mode

   * tab stops, tab and leader characters, escape character, no-break
     and hyphen indicators, margin character data

   * partially collected lines

   These environments may be given arbitrary names (see
Identifiers, for more info).  Old versions of `troff' only had
environments named `0', `1' and `2'.

   The `ev' request will switch to another environment.  The single
argument is the name of the environment to switch to.  With no argument
`gtroff' will switch back to the previous environment.  There is no
limit on the number of named environments; they will be created the
first time that they are referenced.  The `.ev' register contains the
name or number of the current environment.  This is a string-valued
register.

   Note that a call to `ev' (with argument) will push the previously
active environment onto a stack.  If, say, environments `foo', `bar',
and `zap' are called (in that order), the first `ev' request without
parameter will switch back to environment `bar' (which will be popped
off the stack), and a second call will switch back to environment `foo'.

   Here is another example:

     .ev footnote-env
     .fam N
     .ps 6
     .vs 8
     .ll -.5i
     .ev
     ...
     .ev footnote-env
     \(dg Note the large, friendly letters.
     .ev

   To copy an environment into the current one, use the `evc' request,
which takes the name of the environment to copy from as an argument.

I/O
===

   The `so' request will read in the file given as an argument and
include it in place of the `so' request.  This is quite useful for
large documents, i.e. keeping each chapter in a separate file.  See
gsoelim, for more information.

   The `mso' request is the same as the `so' request except that the
file is searched for in the same directories as `tmac.NAME' is searched
for when the `-mNAME' option is specified.

   The `cf' and `trf' requests are to include a file.  It will
transparently output the contents of file filename.  Each line is output
as it were preceded by `\!'; however, the lines are not subject to copy
mode interpretation.  If the file does not end with a newline, then a
newline will be added.  For example, to define a macro `x' containing
the contents of file `f', use

     .di x
     .trf f
     .di

   The request `.cf FILENAME', when used in a diversion, will embed in
the diversion an object which, when reread, will cause the contents of
FILENAME to be transparently copied through to the output.  In UNIX
`troff', the contents of FILENAME is immediately copied through to the
output regardless of whether there is a current diversion; this
behaviour is so anomalous that it must be considered a bug.  This
request causes a line break.

   With `trf', unlike `cf', the file cannot contain characters such as
NUL that are not valid `gtroff' input characters (see Identifiers).
This request causes a line break.

   The `nx' request will force `gtroff' to continue processing of the
file specified as an argument.

   The `rd' request will read from standard input, and include what is
read as though it were part of the input file.  Text is read until a
blank line is encountered.

   Using these two requests it is easy to set up form letters.  The form
letter template is constructed like this:

     .ce
     \*(td
     .sp 2
     .nf
     .rd
     .sp
     .rd
     .fi
     Body of letter.
     .bp
     .nx repeat.let

When this is run, the following file should be redirected in.  Note that
requests included in this file are executed as though they were part of
the form letter.  The last block of input is the `ex' requests which
tells groff to stop processing.  If this was not there, groff would not
know when to stop.

     Trent A. Fisher
     708 NW 19th Av., #202
     Portland, OR  97209

     Dear Trent,

     Len Adollar
     4315 Sierra Vista
     San Diego, CA  92103

     Dear Mr. Adollar,

     .ex

   `pi'

   The `sy' request will allow arbitrary system commands to be executed
from within a `gtroff' document.  The output is not saved anyplace, so
it is up to the user to do so.

   For example, the following example will introduce the current time
into a document:

     .sy perl -e 'printf ".nr H %d\\n.nr M %d\\n.nr S %d\\n",\
     	     (localtime(time))[2,1,0]' > /tmp/x\n[$$]
     .so /tmp/x\n[$$]
     .sy rm /tmp/x\n[$$]
     \nH:\nM:\nS

Note that this works by having the `perl' script (run by `sy') print
out the `nr' requests which will set the number registers `H', `M' and
`S', and then reads those commands in with the `so' request.

   The `systat' number register contains the return value of the
`system()' function executed by the last `sy' request.

   The `open' request will open a file (specified as the second
argument) for writing and associate the stream (specified as the first
argument) with it.

   The `opena' is like `open', but if the file exists, append to it
instead of truncating it.

   The `write' request will write to the file associated with the
stream specified by the first argument.  The stream must previously have
been the subject of an open request.  The remainder of the line is
interpreted as the `ds' request reads its second argument: A leading
`"' will be stripped, and it will be read in copy-in mode.

   The `close' request will close the stream specified by the first
argument; stream will no longer be an acceptable argument to the
`write' request.

   The `\V' escape will interpolate the contents of the specified
environment variable, as returned by the function `getenv'.  The
argument to `\V' is specified as an identifier, i.e.  `\VX', `\V(XX' or
`\V[XXX]'.  `\V' is interpreted in copy-in mode.

Postprocessor Access
====================

   There are two escapes which will allow information to be directly
given to the postprocessor.  This is particularly useful for embedding
POSTSCRIPT into the final document.

   The `\X' escape will embed its argument into the `gtroff' output
preceded with `x X'.

   The `\Y' escape is called with an identifier (i.e.  `\YX', `\Y(XX'
or `\Y[XXX]').  This is approximately equivalent to `\X'\*[XXX]''.
However, the contents of the string or macro XXX are not interpreted;
also it is permitted for XXX to have been defined as a macro and thus
contain newlines (it is not permitted for the argument to `\X' to
contain newlines).  The inclusion of newlines requires an extension to
the UNIX `troff' output format, and will confuse drivers that do not
know about this extension.

   See Output Devices.

Miscellaneous
=============

   This section documents parts of `gtroff' which cannot (yet) be
categorized elsewhere in this manual.

   Line numbers can be printed in the left margin using the `nm'
request.  The first argument is the line number of the _next_ output
line; this defaults to 1.  The second argument indicates on which lines
numbers will be printed, i.e. 5 means put line numbers on every
5 lines; this defaults to 1.  The third argument is the space to be
left between the number and the text; this defaults to 1.  The fourth
argument is the indentation of the line numbers.  Without arguments,
line numbers are turned off.

   The `nn' request will temporarily turn off line numbering.  The
first argument is the number of lines not to be numbered; this defaults
to 1.

   Margin characters can be automatically printed to the right of the
text with the `mc' request.  The first argument is the character to be
printed, and the second argument is the distance away from the main body
text.  With no arguments the margin characters are turned off.  If this
occurs before a break, no margin character will be printed.

   This is quite useful for indicating text that has changed, and, in
fact, there are programs available for doing this (they are called
`nrchbar' and `changebar' and can be found in any `comp.sources.unix'
archive.

   The primary reason for the existence of `lf' is to make debugging
documents which are split into many files, which are then put together
with `soelim' and other preprocessors.  The first argument is the name
of the file and the second argument is the input line number in that
file.  This way `gtroff' can produce error messages which are
intelligible to the user.

Debugging
=========

   `gtroff' is not easy to debug, but there are some useful features
and strategies for debugging.

   * The `tm' request will send output to the standard error stream;
     this is very useful for printing debugging output.

   * When doing something involved it is useful to leave the debugging
     statements in the code and have them turned on by a command line
     flag.

          .if \n(DB .tm debugging output

     To activate these statements say

          groff -rDB=1 file

   * The `ab' request is similar to the `tm' request, except that it
     will cause `gtroff' to stop processing.  With no argument it will
     print `User Abort'.

   * The `ex' request will also cause `gtroff' to stop processing if
     encountered at the topmost level; see also I/O.

   * If it is known in advance that there will be many errors and no
     useful output, `gtroff' can be forced to suppress formatted output
     with the `-z' flag.

   * The `pm' request will dump out the entire symbol table.

   * The `pnr' request will print the names and contents of all
     currently defined number registers on stderr.

   * The `ptr' request will print the names and positions of all traps
     (not including input line traps and diversion traps) on stderr.
     Empty slots in the page trap list are printed as well, because
     they can affect the priority of subsequently planted traps.

   * The `fl' request instructs `gtroff' to flush its output
     immediately.  The intention is that this be used when using
     `gtroff' interactively.  There is little other use for it.  This
     request causes a line break.

   * The `backtrace' request will print a backtrace of the input stack
     to the standard error stream.

   * `gtroff' has command line options for printing out more warnings
     (`-w') and for printing backtraces (`-b') when a warning or an
     error occurs.  The most verbose level of warnings is `-ww'.

   * The `warn' request controls the level of warnings checked for.  The
     only argument is the sum of the numbers associated with each
     warning that is to be enabled; all other warnings will be
     disabled.  The number associated with each warning is listed
     below.  For example, `.warn 0' will disable all warnings, and
     `.warn 1' will disable all warnings except that about missing
     characters.  If an argument is not given, all warnings will be
     enabled.  The number register `.warn' contains the current warning
     level.

Warnings
--------

   The warnings that can be given to `gtroff' are divided into the
following categories.  The name associated with each warning is used by
the `-w' and `-W' options; the number is used by the `warn' request and
by the `.warn' register.

`char'
`1'
     Non-existent characters.  This is enabled by default.

`number'
`2'
     Invalid numeric expressions.  This is enabled by default.  See
     Expressions.

`break'
`4'
     In fill mode, lines which could not be broken so that their length
     was less than the line length.  This is enabled by default.

`delim'
`8'
     Missing or mismatched closing delimiters.

`el'
`16'
     Use of the `el' request with no matching `ie' request.  See
     if-else.

`scale'
`32'
     Meaningless scaling indicators.

`range'
`64'
     Out of range arguments.

`syntax'
`128'
     Dubious syntax in numeric expressions.

`di'
`256'
     Use of `di' or `da' without an argument when there is no current
     diversion.

`mac'
`512'
     Use of undefined strings, macros and diversions.  When an undefined
     string, macro or diversion is used, that string is automatically
     defined as empty.  So, in most cases, at most one warning will be
     given for each name.

`reg'
`1024'
     Use of undefined number registers.  When an undefined number
     register is used, that register is automatically defined to have a
     value of 0.  A definition is automatically made with a value of 0.
     So, in most cases, at most one warning will be given for use of a
     particular name.

`tab'
`2048'
     Use of a tab character where a number was expected.

`right-brace'
`4096'
     Use of `\}' where a number was expected.

`missing'
`8192'
     Requests that are missing non-optional arguments.

`input'
`16384'
     Illegal input characters.

`escape'
`32768'
     Unrecognized escape sequences.  When an unrecognized escape
     sequence is encountered, the escape character is ignored.

`space'
`65536'
     Missing space between a request or macro and its argument.  This
     warning will be given when an undefined name longer than two
     characters is encountered, and the first two characters of the
     name make a defined name.  The request or macro will not be
     invoked.  When this warning is given, no macro is automatically
     defined.  This is enabled by default.  This warning will never
     occur in compatibility mode.

`font'
`131072'
     Non-existent fonts.  This is enabled by default.

`all'
     All warnings except `di', `mac' and `reg'.  It is intended that
     this covers all warnings that are useful with traditional macro
     packages.

`w'
     All warnings.

Implementation Differences
==========================

   GNU `troff' has a number of features which cause incompatibilities
with documents written with old versions of `troff'.

   Long names cause some incompatibilities.  UNIX `troff' will interpret

     .dsabcd

as defining a string `ab' with contents `cd'.  Normally, GNU `troff'
will interpret this as a call of a macro named `dsabcd'.  Also UNIX
`troff' will interpret `\*[' or `\n[' as references to a string or
number register called `['.  In GNU `troff', however, this will
normally be interpreted as the start of a long name.  In compatibility
mode GNU `troff' will interpret these things in the traditional way.  In
compatibility mode, however, long names are not recognized.
Compatibility mode can be turned on with the `-C' command line option,
and turned on or off with the `cp' request.  The number register `.C'
is 1 if compatibility mode is on, 0 otherwise.

   GNU `troff' does not allow the use of the escape sequences `\|',
`\^', `\&', `\}', `\{', `\<SP>', `\'', `\`', `\-', `\_', `\!', `\%',
and `\c' in names of strings, macros, diversions, number registers,
fonts or environments; UNIX `troff' does.  The `\A' escape sequence
(see Identifiers) may be helpful in avoiding use of these escape
sequences in names.

   Fractional point sizes cause one noteworthy incompatibility.  In
UNIX `troff' the `ps' request ignores scale indicators and thus

     .ps 10u

will set the point size to 10 points, whereas in GNU `troff' it will
set the point size to 10 scaled points.  See Fractional Type Sizes,
for more information.

   In GNU `troff' there is a fundamental difference between
unformatted, input characters, and formatted, output characters.
Everything that affects how an output character will be output is stored
with the character; once an output character has been constructed it is
unaffected by any subsequent requests that are executed, including
`bd', `cs', `tkf', `tr', or `fp' requests.  Normally output characters
are constructed from input characters at the moment immediately before
the character is added to the current output line.  Macros, diversions
and strings are all, in fact, the same type of object; they contain
lists of input characters and output characters in any combination.  An
output character does not behave like an input character for the
purposes of macro processing; it does not inherit any of the special
properties that the input character from which it was constructed might
have had.  For example,

     .di x
     \\\\
     .br
     .di
     .x

will print `\\' in GNU `troff'; each pair of input backslashes is
turned into one output backslash and the resulting output backslashes
are not interpreted as escape characters when they are reread.  UNIX
`troff' would interpret them as escape characters when they were reread
and would end up printing one `\'.  The correct way to obtain a
printable backslash is to use the `\e' escape sequence: This will
always print a single instance of the current escape character,
regardless of whether or not it is used in a diversion; it will also
work in both GNU `troff' and UNIX `troff'.  To store, for some reason,
an escape sequence in a diversion that will be interpreted when the
diversion is reread, either use the traditional `\!' transparent output
facility, or, if this is unsuitable, the new `\?' escape sequence.

   See Diversions, for more information.

Summary
=======

Preprocessors
*************

   This chapter describes all preprocessors that come with `groff' or
which are freely available.

`geqn'
======

Invoking `geqn'
---------------

`gtbl'
======

Invoking `gtbl'
---------------

`gpic'
======

Invoking `gpic'
---------------

`ggrn'
======

Invoking `ggrn'
---------------

`grap'
======

   A free implementation of `grap', written by Ted Faber, is available
as an extra package from the following address:

     <http://www.lunabase.org/~faber/Vault/software/grap/>

`grefer'
========

Invoking `grefer'
-----------------

`gsoelim'
=========

Invoking `gsoelim'
------------------

Output Devices
**************

Special Characters
==================

   See Font Files.

`grotty'
========

Invoking `grotty'
-----------------

`grops'
=======

Invoking `grops'
----------------

Embedding POSTSCRIPT
--------------------

`grodvi'
========

Invoking `grodvi'
-----------------

`grolj4'
========

Invoking `grolj4'
-----------------

`grolbp'
========

Invoking `grolbp'
-----------------

`grohtml'
=========

Invoking `grohtml'
------------------

`gxditview'
===========

Invoking `gxditview'
--------------------

File formats
************

`gtroff' Output
===============

   This section describes the format output of GNU `troff'.  The output
format used by GNU `troff' is very similar to that used by UNIX
device-independent `troff' (`ditroff').

Output Format
-------------

   The output format is text based, as opposed to a binary format (like
TeX DVI).  The output format is 8-bit clean, thus single characters can
have the eighth bit set, as can the names of fonts and special
characters.

   The output format consists of single command characters with attached
parameters which are separated from subsequent text by whitespace or a
newline.

   The names of characters and fonts can be of arbitrary length; drivers
should not assume that they will be only two characters long (as
`ditroff' does).

   When a character is to be printed, that character will always be in
the current font.  Unlike `ditroff', it is not necessary for drivers to
search special fonts to find a character.

`HN'

`VN'

`hN'

`vN'

`cN'

`CN'

`NNC'

`tXXX'
     XXX is any sequence of characters terminated by a space or a
     newline; the first character should be printed at the current
     position, the the current horizontal position should be increased
     by the width of the first character, and so on for each character.
     The width of the character is that given in the font file,
     appropriately scaled for the current point size, and rounded so
     that it is a multiple of the horizontal resolution.  Special
     characters cannot be printed using this command.

     This command is only allowed if the `tcommand' line is present in
     the `DESC' file.

`uN XXX'
     This is same as the `t' command except that after printing each
     character, the current horizontal position is increased by the sum
     of the width of that character and N.

     This command is only allowed if the `tcommand' line is present in
     the `DESC' file.

`nAB'

`pN'

`sN'
     The argument to the `s' command is in scaled points (units of
     points/N, where N is the argument to the `sizescale' command in
     the `DESC' file).

`fN'

`x ... \n'
     Device control.

`DC X...\n'

Device Control
--------------

   The `x' command is normally followed by a letter or word indicating
the function to perform, followed by white space separated arguments.

   The first argument can be abbreviated to the first letter.

`x init'

`x T'

`x res N H V'

`x H'
     The argument to the `x Height' command is also in scaled points.

   The first three output commands are guaranteed to be:

     x T device
     x res n h v
     x init

For example, the input

     crunchy \fH\s+2frog\s0\fP!?

will produce

Drawing Functions
-----------------

   The `D' drawing command has been extended.  These extensions will
only be used by GNU `pic' if the `-x' option is given.

   See Drawing Requests.

`Df N'
     Set the shade of gray to be used for filling solid objects to N;
     N must be an integer between 0 and 1000, where 0 corresponds solid
     white and 1000 to solid black, and values in between correspond to
     intermediate shades of gray.  This applies only to solid circles,
     solid ellipses and solid polygons.  By default, a level of 1000
     will be used.  Whatever color a solid object has, it should
     completely obscure everything beneath it.  A value greater
     than 1000 or less than 0 can also be used: this means fill with
     the shade of gray that is currently being used for lines and text.
     Normally this will be black, but some drivers may provide a way
     of changing this.

`DC D'
     Draw a solid circle with a diameter of D with the leftmost point
     at the current position.

`DE DX DY'
     Draw a solid ellipse with a horizontal diameter of DX and a
     vertical diameter of DY with the leftmost point at the current
     position.

`Dp DX1 DY1 DX2 DY2 ... DXN DYN'
     Draw a polygon with.  The first vertex is at the current position,
     the second vertex at an offset (DX1,DY1) from the current
     position, the second vertex at an offset (DX2,DY2) from the first
     vertex, and so on up to the N-th vertex.  At the moment, GNU `pic'
     only uses this command to generate triangles and rectangles.

`DP DX1 DY1 DX2 DY2 ... DXN DYN'
     Like `Dp' but draw a solid rather than outlined polygon.

`Dt N'
     Set the current line thickness to N machine units.  Traditionally,
     UNIX `troff' drivers use a line thickness proportional to the
     current point size; drivers should continue to do this if no `Dt'
     command has been given, or if a `Dt' command has been given with a
     negative value of N.  A zero value of N selects the smallest
     available line thickness.

   A difficulty arises in how the current position should be changed
after the execution of these commands.  This is not of great importance
since the code generated by GNU `pic' does not depend on this.  Given a
drawing command of the form

     \D'C X1 Y1 X2 Y2 ... XN YN'

where C is not one of `c', `e', `l', `a' or `~', UNIX `troff' will
treat each of the x value as a horizontal quantity, and each of the
y values as a vertical quantity and will assume that the width of the
drawn object is sum if all x values, and that the height is the sum of
all y values.  (The assumption about the height can be seen by
examining the `st' and `sb' registers after using such a `D' command in
a `\w' escape sequence.)  This rule also holds for all the original
drawing commands with the exception of `De'.  For the sake of
compatibility GNU `troff' also follows this rule, even though it
produces an ugly result in the case of the `Df', `Dt', and, to a lesser
extent, `DE' commands.  Thus after executing a `D' command of the form

     DC X1 Y1 X2 Y2 ... XN YN

the current position should be increased horizontally by the sum of all
x values and vertically by the sum of all y values.

Line Continuation
-----------------

   There is a continuation convention which permits the argument to the
`x X' command to contain newlines: When outputting the argument to the
`x X' command, GNU `troff' will follow each newline in the argument
with a `+' character (as usual, it will terminate the entire argument
with a newline); thus if the line after the line containing the `x X'
command starts with `+', then the newline ending the line containing
the `x X' command should be treated as part of the argument to the
`x X' command, the `+' should be ignored, and the part of the line
following the `+' should be treated like the part of the line following
the `x X' command.

Font Files
==========

   The `gtroff' font format is roughly a superset of the `ditroff' font
format.  Unlike the `ditroff' font format, there is no associated
binary format; all files are text files.  The font files for device
NAME are stored in a directory `devNAME'.  There are two types of file:
a device description file called `DESC' and for each font F a font file
called `F'.

`DESC' file format
------------------

   The `DESC' file can contain the following types of line:

`res N'
     There are N machine units per inch.

`hor N'
     The horizontal resolution is N machine units.

`vert N'
     The vertical resolution is N machine units.

`sizescale N'
     The scale factor for point sizes.  By default this has a value
     of 1.  One scaled point is equal to one point/N.  The arguments to
     the `unitwidth' and `sizes' commands are given in scaled points.
     See Fractional Type Sizes, for more information.

`unitwidth N'
     Quantities in the font files are given in machine units for fonts
     whose point size is N scaled points.

`tcommand'
     This means that the postprocessor can handle the `t' and `u'
     output commands.

`sizes S1 S2 ... SN 0'
     This means that the device has fonts at S1, S2, ...  SN scaled
     points.  The list of sizes must be terminated by a 0.  Each SI can
     also be a range of sizes M-N.  The list can extend over more than
     one line.

`styles S1 S2 ... SM'
     The first M font positions will be associated with styles S1 ...
     SM.

`fonts N F1 F2 F3 ... FN'
     Fonts F1 ... FN will be mounted in the font positions M+1, ...,
     M+N where M is the number of styles.  This command may extend over
     more than one line.  A font name of 0 will cause no font to be
     mounted on the corresponding font position.

`family FAM'
     The default font family is FAM.

`charset'
     This line and everything following in the file are ignored.  It is
     allowed for the sake of backwards compatibility.

   The `res', `unitwidth', `fonts' and `sizes' lines are mandatory.
Other commands are ignored by `gtroff' but may be used by
postprocessors to store arbitrary information about the device in the
`DESC' file.

Font file format
----------------

   A font file has two sections.  The first section is a sequence of
lines each containing a sequence of blank delimited words; the first
word in the line is a key, and subsequent words give a value for that
key.

`name F'
     The name of the font is F.

`spacewidth N'
     The normal width of a space is N.

`slant N'
     The characters of the font have a slant of N degrees.  (Positive
     means forward.)

`ligatures LIG1 LIG2 ... LIGN [0]'
     Characters LIG1, LIG2, ..., LIGN are ligatures; possible ligatures
     are `ff', `fi', `fl', `ffi' and `ffl'.  For backwards
     compatibility, the list of ligatures may be terminated with a 0.
     The list of ligatures may not extend over more than one line.

`special'
     The font is special; this means that when a character is requested
     that is not present in the current font, it will be searched for
     in any special fonts that are mounted.

   Other commands are ignored by `gtroff' but may be used by
postprocessors to store arbitrary information about the font in the font
file.

   The first section can contain comments which start with the `#'
character and extend to the end of a line.

   The second section contains one or two subsections.  It must contain
a `charset' subsection and it may also contain a `kernpairs'
subsection.  These subsections can appear in any order.  Each
subsection starts with a word on a line by itself.

   The word `charset' starts the character set subsection.  The
`charset' line is followed by a sequence of lines.  Each line gives
information for one character.  A line comprises a number of fields
separated by blanks or tabs.  The format is

     NAME METRICS TYPE CODE COMMENT

NAME identifies the character: If NAME is a single character C then it
corresponds to the `gtroff' input character C; if it is of the form
`\C' where C is a single character, then it corresponds to the `gtroff'
input character \C; otherwise it corresponds to the groff input
character `\[NAME]'.  (If it is exactly two characters XX it can be
entered as `\(XX'.)  `gtroff' supports 8-bit characters; however some
utilities have difficulties with eight-bit characters.  For this
reason, there is a convention that the name `charN' is equivalent to
the single character whose code is N.  For example, `char163' would be
equivalent to the character with code 163 which is the pounds sterling
sign in ISO Latin-1 character set.  The name `---' is special and
indicates that the character is unnamed; such characters can only be
used by means of the `\N' escape sequence in `gtroff'.

   The TYPE field gives the character type:

`1'
     the character has an descender, for example, `p';

`2'
     the character has an ascender, for example, `b';

`3'
     the character has both an ascender and a descender, for example,
     `('.

   The CODE field gives the code which the postprocessor uses to print
the character.  The character can also be input to `gtroff' using this
code by means of the `\N' escape sequence.  The code can be any
integer.  If it starts with `0' it will be interpreted as octal; if it
starts with `0x' or `0X' it will be interpreted as hexadecimal.

   Anything on the line after the CODE field will be ignored.

   The METRICS field has the form:

     WIDTH[,HEIGHT[,DEPTH[,ITALIC_CORRECTION
       [,LEFT_ITALIC_CORRECTION[,SUBSCRIPT_CORRECTION]]]]]

There must not be any spaces between these subfields (it has been split
here into two lines for better legibility only).  Missing subfields are
assumed to be 0.  The subfields are all decimal integers.  Since there
is no associated binary format, these values are not required to fit
into a variable of type `char' as they are in `ditroff'.  The WIDTH
subfield gives the width of the character.  The HEIGHT subfield gives
the height of the character (upwards is positive); if a character does
not extend above the baseline, it should be given a zero height, rather
than a negative height.  The DEPTH subfield gives the depth of the
character, that is, the distance below the lowest point below the
baseline to which the character extends (downwards is positive); if a
character does not extend below above the baseline, it should be given
a zero depth, rather than a negative depth.  The ITALIC_CORRECTION
subfield gives the amount of space that should be added after the
character when it is immediately to be followed by a character from a
Roman font.  The LEFT_ITALIC_CORRECTION subfield gives the amount of
space that should be added before the character when it is immediately
to be preceded by a character from a Roman font.  The
SUBSCRIPT_CORRECTION gives the amount of space that should be added
after a character before adding a subscript.  This should be less than
the italic correction.

   A line in the `charset' section can also have the format

     NAME "

This indicates that NAME is just another name for the character
mentioned in the preceding line.

   The word `kernpairs' starts the kernpairs section.  This contains a
sequence of lines of the form:

     C1 C2 N

   This means that when character C1 appears next to character C2 the
space between them should be increased by N.  Most entries in kernpairs
section will have a negative value for N.

Installation
************

Request and Escape Index
************************

   In this index, escapes are listed with a leading backslash (`\') to
distinguish them from requests which appear without the leading control
character (normally either `.' or `'').

Operator Index
**************

Macro and String Index
**********************

   In this index, strings are listed with the calling escape sequence
(`\*') to distinguish them from macros which appear without the leading
control character (normally either `.' or `'').

Glyph Name Index
****************

   A glyph name `xx' consisting of exactly two characters can be
accessed as `\(xx'.  Glyph names `xxx' of any length can be accessed as
`\[xxx]'.